<?php
require_once("../../../classes/class.users.php");
require_once("../../../classes/class.validation.php");
require_once("../../../classes/class.authentication.php");

require_once('../../../classes/school_administration/class.academic_years.php');
require_once("../../../classes/school_administration/class.students.php");
require_once("../../../classes/school_administration/class.parent_details.php");
require_once("../../../classes/school_administration/class.student_details.php");

require_once("../../../classes/school_administration/class.classes.php");
require_once("../../../classes/school_administration/class.section_master.php");
require_once("../../../classes/school_administration/class.class_sections.php");
require_once("../../../classes/academic_supervision/class.student_Cc_details.php");
require_once("../../../classes/class.date_processing.php");
require_once("../../../includes/global_defaults.inc.php");

//1. RECHECK IF THE USER IS VALID //
try {
    $AuthObject = new ApplicationAuthentication;
    $LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e) {
    header('location:/admin/unauthorized_login_admin.php');
    exit;
} catch (Exception $e) {
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}
// END OF 1. //

if ($LoggedUser->HasPermissionForTask(TASK_EDIT_STUDENT) !== true) {
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}

$Clean = array();

$Clean['StudentID'] = 0;

if (isset($_GET['StudentID'])) {
    $Clean['StudentID'] = (int) $_GET['StudentID'];
} elseif (isset($_POST['hdnStudentID'])) {
    $Clean['StudentID'] = (int) $_POST['hdnStudentID'];
}

if ($Clean['StudentID'] <= 0) {
    header('location:../../error.php');
    exit;
}

try {
    $StudentObject = new StudentDetail($Clean['StudentID']);
} catch (ApplicationDBException $e) {
    header('location:../../error.php');
    exit;
} catch (Exception $e) {
    header('location:../../error.php');
    exit;
}

//print_r($StudentObject);exit;

$HasErrors = false;

$AcademicYearID = 0;
$AcademicYearName = '';

$AcademicYearID = AcademicYear::GetCurrentAcademicYear($AcademicYearName);

$Clean['Process'] = 0;

$Clean['ClassSectionID'] = 0;
$Clean['ClassID'] = 0;
$Clean['Class'] = '';

$Clean['FirstName'] = '';
$Clean['LastName'] = '';

$Clean['DOB'] = '';
$Clean['Gender'] = '';

$Clean['Address1'] = '';
$Clean['Address2'] = '';

$Clean['FatherFirstName'] = '';
$Clean['FatherLastName'] = '';
$Clean['MotherFirstName'] = '';
$Clean['MotherLastName'] = '';

$SchoolName = '';
$AffilationDetails = 'Affiliated C.B.S.E Board New Delhi';
$Address = 'Tiloi Distt. Amethi (U.P.)';
$Pincode = 229309;
$City = 'Amethi';
$State = 'UP';
$ContactNumber = '0535-2634282';
$AffilationNumber = '2132953';


$SchoolName = 'PRITHVIRAJ CHAUHAN EDUCATION CENTRE';
$AffilationDetails = 'School No.70772';
$OtherDetails = 'Run Under Christian Community Educational Society, Sitapur';
$Address = 'Bhauti, Pratappur, Kanpur Nagar-224135';
$Affilation = '(Affilated to C.B.S.C. upto Sr.-Secondary Level)';
$City = 'SITAPUR';
$State = 'UP';
$ContactNumber = 'Phone No.8853942696, 7097542696';
$AffilationNumber = '';

$Clean['ClassSectionID'] = $StudentObject->GetClassSectionID();

$ClassSectionDetails = new ClassSections($StudentObject->GetClassSectionID());

$ClassObject = new AddedClass($ClassSectionDetails->GetClassID());

$StudentCCDetails = array();
$StudentCCDetails = StudentCcDetail::AllStudentCCDetails($Clean['StudentID']);

$Clean['Class'] = $ClassObject->GetClassName();
$Clean['FirstName'] = $StudentObject->GetFirstName();
$Clean['LastName'] = $StudentObject->GetLastName();
$Clean['DOB'] = date('d/m/Y', strtotime($StudentObject->GetDOB()));
$Clean['Gender'] = $StudentObject->GetGender();
$Clean['Address'] = $StudentObject->GetAddress1();
if ($Clean['Address'] == '') {
    $Clean['Address'] = $StudentObject->GetAddress2();
}
$Clean['AdmissionDate'] = date('d/m/Y', strtotime($StudentObject->GetAdmissionDate()));

$NewParentDetail = new ParentDetail($StudentObject->GetParentID());

$Clean['FatherFirstName'] = $NewParentDetail->GetFatherFirstName();
$Clean['FatherLastName'] = $NewParentDetail->GetFatherLastName();
$Clean['MotherFirstName'] = $NewParentDetail->GetMotherFirstName();
$Clean['MotherLastName'] = $NewParentDetail->GetMotherLastName();

require_once('../../html_header.php');
?>
<title>Character Certificate</title>
<link href="../../vendor/jquery-ui/jquery-ui.min.css" rel="stylesheet">
</head>

<body>

    <div id="wrapper">
        <!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
            <?php
            require_once('../../site_header.php');
            require_once('../../left_navigation_menu.php');
            ?>
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">Character Certificate</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <strong>Character Certificate</strong>
                </div>
                <div class="panel-body">
                    <div>
                        <div class="pull-right">
                            <div class="print-btn-container"><button id="PrintButton" type="submit" class="btn btn-primary">Print</button></div>
                        </div>
                        <div id="RecordTableHeading">
                            <center>
                                <div class="align-center" style="position: relative; bottom: 5px; width:750px; height:540px; border:10px solid black; display:block; border-collapse: collapse;">
                                    <div class="align-center" style="position: relative; border:3px solid gray; display:block; margin: 5px; height:510px;">

                                        <div style="height:100px; width:150px; margin-left:10px; float:left; margin-top:20px;">
                                             <img src="../../../site_images/school_logo/school_logo.png" height="70px;" width="80px;" style="margin-left:22px; margin-top:10px;" align="center;"> 
                                            <!--<br><strong><small>Affilation No: <?php echo $AffilationNumber; ?></small></strong>-->
                                        </div>
                                        <?php
                                        if (count($StudentCCDetails) > 0) {
                                        ?>
                                            <div class="pull-right print-hidden" style="margin-right: 3px; margin-top:3px">
                                                <a class="btn btn-sm btn-info edit-record" data-toggle="modal" data-target="#editStudentDetails" data-id="<?php echo $StudentCCDetails[$Clean['StudentID']]['StudentID'];   ?>" data-studentname="<?php echo $StudentCCDetails[$Clean['StudentID']]['StudentName']; ?>" data-fathername="<?php echo $StudentCCDetails[$Clean['StudentID']]['ParentsName']; ?>" data-admission="<?php echo $StudentCCDetails[$Clean['StudentID']]['AdmissionDate']; ?>" data-academicyear="<?php echo $StudentCCDetails[$Clean['StudentID']]['AcademicYear']; ?>" data-adress="<?php echo $StudentCCDetails[$Clean['StudentID']]['Address']; ?>" data-class="<?php echo $StudentCCDetails[$Clean['StudentID']]['Class']; ?>" href="#" title="" data-toggle="tooltip" data-original-title="Edit">Edit
                                                </a>
                                            </div>
                                        <?php } else {
                                        ?>
                                            <div class="pull-right print-hidden" style="margin-right: 3px; margin-top:3px">
                                                <a class="btn btn-sm btn-info edit-record" data-toggle="modal" data-target="#editStudentDetails" data-id="<?php echo $Clean['StudentID'];   ?>" data-studentname="<?php echo $Clean['FirstName'] . ' ' . $Clean['LastName']; ?>" data-fathername="<?php echo $Clean['FatherFirstName'] . '' . $Clean['FatherLastName']; ?>" data-mothername="<?php echo $Clean['MotherFirstName'] . '' . $Clean['MotherLastName']; ?>" data-admission="<?php echo $Clean['AdmissionDate']; ?>" data-academicyear="<?php echo $AcademicYearName; ?>" data-adress="<?php echo $Clean['Address']; ?>" data-class="<?php echo $Clean['Class']; ?>" href="#" title="" data-toggle="tooltip" data-original-title="Edit">Edit
                                                </a>
                                            </div>
                                        <?php
                                        }
                                        ?>
                                        <div style="height:100px; width:450px; float:left; margin-top:10px; text-align:center;">
                                            <strong style="font-size:20px;"><?php echo $SchoolName; ?></strong>
                                            <br><strong style="font-size:18px;"><?php echo $AffilationDetails; ?></strong>
                                            <br><strong style="font-size:15px;"><?php echo $Address . '<br>' . $ContactNumber; ?></strong>
                                        </div>
                                        <center>
                                            <div style="height:50px; width:320px; margin-top:120px; text-align:center; border:1px solid black; display:block; border-radius: 15px; box-shadow: 3px 5px;">
                                                <p style="font-family: cursive; font-size:20px; margin-top: 10px; text-shadow: 0 0 1px;"><i>CHARACTER CERTIFICATE</i></p>
                                            </div>
                                        </center>
                                        <div style="margin-top: 30px; margin-left: 10px;">
                                            <?php
                                            if (count($StudentCCDetails) > 0) {
                                            ?>
                                                <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;">Certified that <span style="border-bottom: 1px dotted #000; text-decoration: none; width: 510px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $StudentCCDetails[$Clean['StudentID']]['StudentName']; ?></b></span></p>

                                                <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;"> S/o, D/o Mr.&nbsp; <span style="border-bottom: 1px dotted #000; text-decoration: none; width: 506px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $StudentCCDetails[$Clean['StudentID']]['ParentsName']; ?></b></span></p>

                                                <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;">Address <span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 550px; "><b>&nbsp;&nbsp;&nbsp;<?php echo $StudentCCDetails[$Clean['StudentID']]['Address']; ?></b></span></p>

                                                <p style="font-family: cursive; font-size:18px;  margin-top: 10px; display: flex;"> is studying/passed in class <span class="unique-function" style="font-family: cursive; font-size:17px; border-bottom: 1px dotted #000; text-decoration: none; width: 50px; "><b>&nbsp;&nbsp;<?php echo $StudentCCDetails[$Clean['StudentID']]['Class']; ?></b></span> in this institution from <span class="unique-function" style="font-family: normal; font-size:17px; border-bottom: 1px dotted #000; text-decoration: none; width: 110px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo date('d/m/Y', strtotime($StudentCCDetails[$Clean['StudentID']]['AdmissionDate'])); ?></b></span>to <span class="unique-function" style="font-family: normal; font-size:17px; border-bottom: 1px dotted #000; text-decoration: none; width: 90px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $StudentCCDetails[$Clean['StudentID']]['AcademicYear']; ?></b></span></p>

                                                <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 25px; display: flex;"> To the best of my knowledge & belief he/she bears a good moral character. </p>
                                                <p style="font-family: cursive; font-size:18px; display: flex;"> I wish him/her success in life. </p>
                                            <?php
                                            } else {
                                            ?>
                                                <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;">Certified that <span style="border-bottom: 1px dotted #000; text-decoration: none; width: 510px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['FirstName'] . ' ' . $Clean['LastName']; ?></b></span></p>

                                                <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;"> S/o, D/o Mr.&nbsp; <span style="border-bottom: 1px dotted #000; text-decoration: none; width: 506px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['FatherFirstName'] . ' ' . $Clean['FatherLastName']; ?></b></span></p>

                                                <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;">Address <span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 550px; "><b>&nbsp;&nbsp;&nbsp;<?php echo $Clean['Address']; ?></b></span></p>

                                                <p style="font-family: cursive; font-size:18px;  margin-top: 10px; display: flex;"> is studying/passed in class <span class="unique-function" style="font-family: cursive; font-size:17px; border-bottom: 1px dotted #000; text-decoration: none; width: 50px; "><b>&nbsp;&nbsp;<?php echo $Clean['Class']; ?></b></span> in this institution from <span class="unique-function" style="font-family: normal; font-size:17px; border-bottom: 1px dotted #000; text-decoration: none; width: 110px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['AdmissionDate']; ?></b></span>to <span class="unique-function" style="font-family: normal; font-size:17px; border-bottom: 1px dotted #000; text-decoration: none; width: 90px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $AcademicYearName; ?></b></span></p>

                                                <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 25px; display: flex;"> To the best of my knowledge & belief he/she bears a good moral character. </p>
                                                <p style="font-family: cursive; font-size:18px; display: flex;"> I wish him/her success in life. </p>
                                            <?php
                                            }
                                            ?>
                                        </div>
                                        <div style="margin-top: 30px; margin-left: 20px;">
                                            <div style="font-family: cursive; font-size:18px; font-weight: 22px;">
                                                <span style="float: left">Date:</span>
                                                <span>Office signature</span>
                                                <span style="position: relative; float: right; bottom: 25px; right: 23px;">Principal<br>(signature with stamp)</span>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </center>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- /#page-wrapper -->
    </div>
    <!-- /#wrapper -->
    <?php
    require_once('../../footer.php');
    ?>
    <div class="modal fade" id="editStudentDetails" tabindex="-1" role="dialog" aria-labelledby="editStudentDetails">
        <div class="modal-dialog modal-sm" role="document">
            <div class="modal-content">
                <form class="myEditModalForm" data-url="<?php echo SITE_HTTP_PATH; ?>/xhttp_calls/edit_student_details.php">
                    <div class="modal-header">
                        <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span aria-hidden="true">&times;</span></button>
                        <h4 class="modal-title" id="myModalLabel">Edit Student Details</h4>
                    </div>
                    <div class="modal-body">
                        <div class="form-group">
                            <div class="alert alert-danger" style="display: none;" id="error-msg-box">
                                <strong>Error!</strong> <span id="error-msg"></span>
                            </div>
                            <div class="form-group">
                                <label for="LedgerName" class="control-label">Student Name</label>
                                <input type="text" required name="studentName" placeholder="Student Name" class="form-control clear" id="studentName" value="">
                            </div>
                            <div class="form-group">
                                <label for="LedgerName" class="control-label">Parents Name</label>
                                <input type="text" required name="parentsName" placeholder="Parents Name" class="form-control clear" id="parentsName" value="">
                            </div>
                            <div class="form-group">
                                <label for="LedgerName" class="control-label">Address</label>
                                <input type="text" required name="address" placeholder="Address" class="form-control clear" id="address" value="">
                            </div>
                            <div class="form-group">
                                <label for="LedgerName" class="control-label">Class</label>
                                <input type="text" required name="class" placeholder="Class" class="form-control clear" id="class" value="">
                            </div>
                            <div class="form-group">
                                <label for="LedgerName" class="control-label">Admission Date</label>
                                <input type="date" required name="admissionDate" placeholder="Admission Date" class="form-control clear" id="admissionDate" value="">
                            </div>
                            <div class="form-group">
                                <label for="LedgerName" class="control-label">Academic Year</label>
                                <input type="text" required name="academicYear" placeholder="Academic Year" class="form-control clear" id="academicYear" value="">
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <input type="hidden" name="id" value="">
                        <button type="button" class="btn btn-default" data-dismiss="modal">Close</button>
                        <button type="submit" class="btn btn-primary">Save changes</button>
                    </div>
                </form>
            </div>
        </div>
    </div>
    <script src="/admin/vendor/jquery-ui/jquery-ui.min.js"></script>
    <script src="../../js/print-report.js"></script>
    <script type="text/javascript">
        $(document).ready(function() {
            // $('.unique-function').click(function() {

            //     var DataValue = prompt('Enter Details', $(this).text().trim());
            //     if (DataValue) {
            //         $(this).html('&nbsp;&nbsp;<b>' + DataValue + '</b>');
            //     }
            // });

            $('#editStudentDetails').on('show.bs.modal', function(event) {
                var button = $(event.relatedTarget) // Button that triggered the modal

                var id = button.data('id');
                var studentName = button.data('studentname');
                var parentsName = button.data('fathername');
                var classs = button.data('class');
                var adress = button.data('adress');
                var admissionDate = button.data('admission');
                var academicYear = button.data('academicyear');

                var modal = $(this)

                modal.find('.modal-body #studentName').val(studentName);
                modal.find('.modal-body #parentsName').val(parentsName);
                modal.find('.modal-body #address').val(adress);
                modal.find('.modal-body #class').val(classs);
                modal.find('.modal-body #admissionDate').val(admissionDate);
                modal.find('.modal-body #academicYear').val(academicYear);

                modal.find('.modal-footer input[name=id]').val(id);
            });

            $('.myEditModalForm').on('submit', function(e) {
                e.preventDefault();

                var postURL = $(this).data('url');
                console.log(postURL);
                $.ajax({
                    type: 'post',
                    url: postURL,
                    data: $('.myEditModalForm').serialize(),
                    success: function(data) {
                        var ResultArray = data.split("|*****|");

                        if (ResultArray[0] != 'success') {
                            $('#edit-error-msg-box').css('display', 'block');
                            $('#edit-error-msg').html(ResultArray[1]);
                            return false;
                        } else {
                            $('#editStudentDetails').hide();
                            alert(ResultArray[1]);
                            setTimeout(() => {
                                window.location.href = '<?php echo SITE_HTTP_PATH; ?>' + '/admin/academic_supervision/certificate_formats/character_certificate.php?StudentID=<?php echo $Clean['StudentID']; ?>';
                            }, 500);
                        }
                    }
                });
            });
        });
    </script>
</body>

</html>