<?php
require_once('../../classes/class.users.php');
require_once('../../classes/class.validation.php');
require_once('../../classes/class.authentication.php');
require_once('../../classes/class.authentication.php');
require_once('../../classes/class.date_processing.php');

require_once('../../classes/school_administration/class.academic_year_months.php');

require_once('../../classes/school_administration/class.classes.php');
require_once('../../classes/school_administration/class.class_sections.php');
require_once('../../classes/school_administration/class.students.php');
require_once('../../classes/school_administration/class.student_details.php');

require_once('../../classes/school_administration/class.class_helpers.php');
require_once('../../classes/academic_supervision/class.student_Cc_details.php');


require_once('../../includes/global_defaults.inc.php');

//1. RECHECK IF THE USER IS VALID //
try
{
	$AuthObject = new ApplicationAuthentication;
	$LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
	header('location:../unauthorized_login_admin.php');
	exit;
}
catch (Exception $e)
{
	header('location:../unauthorized_login_admin.php');
	exit;
}
// END OF 1. //

if ($LoggedUser->HasPermissionForTask(CHARACTER_CERTIFICATE) !== true)
{
	header('location:/admin/unauthorized_login_admin.php');
	exit;
}

$AcademicYearMonths =  array();
$AcademicYearMonths =  AcademicYearMonth::GetMonthsByFeePriority();

$ClassList =  array();
$ClassList = AddedClass::GetActiveClasses();

$ClassSectionsList = array();

$RecordDeletedSuccessfully = false;
$HasErrors = false;
$SearchErrors = false;

$Clean = array();
$Clean['Process'] = 0;

$Clean['StudentID'] = 0;
$Clean['ClassID'] = 0;
$Clean['ClassSectionID'] = 0;

$Clean['SessionLastDate'] = '';
$Clean['TCIssueDate'] = '';
$Clean['SchoolLeavingDate'] = '';
$Clean['ReasonForLeaving'] = '';

$Clean['StudentIDList'] = array();

$StudentsList = array();
$TCStudentsList = array();

$TotalRecords = 0;

if (isset($_GET['hdnProcess']))
{
	$Clean['Process'] = (int) $_GET['hdnProcess'];
}
else if (isset($_GET['Process']))
{
	$Clean['Process'] = (int) $_GET['Process'];
}
switch ($Clean['Process'])
{
	case 5:
// 		if ($LoggedUser->HasPermissionForTask(TASK_ADD_EDIT_FEE_GROUP) !== true)
//         {
//             header('location:/admin/unauthorized_login_admin.php');
//             exit;
//         }
        
        if (isset($_GET['StudentID']))
        {
            $Clean['StudentID'] = (int) $_GET['StudentID'];           
        }
       
        if ($Clean['StudentID'] <= 0)
        {
            header('location:../error_page.php');
            exit;
        }                       
        
        $SearchValidator = new Validator();
           
        if (!StudentCcDetail::DeleteStudentCC($Clean['StudentID']))
        {
            $SearchValidator->AttachTextError('Error in executing query.');
            $HasErrors = true;
            break;
        }
        
        $RecordDeletedSuccessfully = true;
	break;

    case 7:
        
        if (isset($_GET['drdClass'])) 
        {
            $Clean['ClassID'] = (int) $_GET['drdClass'];
        }

        if (isset($_GET['drdClassSection'])) 
        {
            $Clean['ClassSectionID'] = (int) $_GET['drdClassSection'];
        }
        
        if (isset($_GET['txtSessionLastDate']))
        {
            $Clean['SessionLastDate'] = strip_tags(trim($_GET['txtSessionLastDate']));
        }
        
        if (isset($_GET['txtTCIssueDate']))
        {
            $Clean['TCIssueDate'] = strip_tags(trim($_GET['txtTCIssueDate']));
        }
        
        if (isset($_GET['txtSchoolLeavingDate']))
        {
            $Clean['SchoolLeavingDate'] = strip_tags(trim($_GET['txtSchoolLeavingDate']));
        }
        
        if (isset($_GET['drdReasonForLeaving']))
        {
            $Clean['ReasonForLeaving'] = strip_tags(trim($_GET['drdReasonForLeaving']));
        }

        $NewRecordValidator = new Validator();
        
        if ($Clean['ClassID'] > 0)
        {
            if ($NewRecordValidator->ValidateInSelect($Clean['ClassID'], $ClassList, 'Please select a class.')) 
            {
                $ClassSectionsList = ClassSections::GetClassSections($Clean['ClassID']);
                
                if ($Clean['ClassSectionID'] > 0)
                {
                    $NewRecordValidator->ValidateInSelect($Clean['ClassSectionID'], $ClassSectionsList, 'Please select a section.');   
                }
            }   
        }
        
       
        
        if ($NewRecordValidator->HasNotifications())
        {
            $HasErrors = true;
            break;
        }
        
        $Filters['ClassID'] = $Clean['ClassID'];
        $Filters['ClassSectionID'] = $Clean['ClassSectionID'];
        
        if ($Clean['SessionLastDate'] != '') 
        {
            $Filters['SessionLastDate'] = date('Y-m-d', strtotime(DateProcessing::ToggleDateDayAndMonth(($Clean['SessionLastDate']))));
        }
        
        
        
        $Filters['ReasonForLeaving'] = $Clean['ReasonForLeaving'];
        
        StudentCcDetail::SearchStudentCCDetails($TotalRecords, true, $Filters);
        
        $CCStudentsList = StudentCcDetail::SearchStudentCCDetails($TotalRecords, false, $Filters, 0, $TotalRecords);
        
        // $StudentsList = StudentDetail::GetStudentsByClassSectionID($Clean['ClassSectionID'], 'Active');
        
    break;
}

require_once('../html_header.php');
?>
<title>View Generated TC</title>
<link href="../vendor/jquery-ui/jquery-ui.min.css" rel="stylesheet">
</head>

<body>

    <div id="wrapper">
    	<!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
<?php 
			require_once('../site_header.php');
			require_once('../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">View Generated CC</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
             <form class="form-horizontal" name="GenerateTransferCertificate" action="view_generated_Cc.php" method="get">
            	<div class="panel panel-default">
                    <div class="panel-heading">
                        Enter Details
                    </div>
                    <div class="panel-body">
<?php
						if ($HasErrors == true)
						{
							echo $NewRecordValidator->DisplayErrorsInTable();
						}
						else if ($RecordDeletedSuccessfully == true)
                        {
                            echo '<div class="alert alert-danger">Record deleted successfully.</div>';
                        }
?>                    
						<br>
                        <div class="form-group">
                            <label for="Class" class="col-lg-2 control-label">Class</label>
                            <div class="col-lg-3">
                                <select class="form-control"  name="drdClass" id="Class">
                                    <option  value="0" >-- Select Class --</option>
<?php
                                    if (is_array($ClassList) && count($ClassList) > 0)
                                    {
                                        foreach ($ClassList as $ClassID => $ClassName)
                                        {
?>
                                            <option <?php echo ($ClassID == $Clean['ClassID'] ? 'selected="selected"' : ''); ?> value="<?php echo $ClassID; ?>"><?php echo $ClassName; ?></option>
<?php
                                        }
                                    }
?>
                                </select>
                            </div>
                            <label for="Class" class="col-lg-2 control-label">Section</label>
                            <div class="col-lg-3">
                                <select class="form-control" name="drdClassSection" id="ClassSection">
                                    <option value="0">-- Select Section --</option>
<?php
                                if (is_array($ClassSectionsList) && count($ClassSectionsList) > 0)
                                {
                                    foreach ($ClassSectionsList as $ClassSectionID => $SectionName) 
                                    {
                                        echo '<option '.($Clean['ClassSectionID'] == $ClassSectionID ? 'selected="selected"' : '') .' value="'. $ClassSectionID .'">'. $SectionName .'</option>';
                                    }
                                }
?>
                                </select>
                            </div>
                        </div>
                        
                        
                        
                        <div class="form-group">
                        <div class="col-sm-offset-2 col-lg-10">
                        	<input type="hidden" name="hdnProcess" value="7" />
							<button type="submit" class="btn btn-primary"><i class="fa fa-search"></i>&nbsp;Search</button>
                        </div>
                      </div>
                    </div>
                </div>
            </form>

<?php
        if ($Clean['Process'] == 7 && $HasErrors == false)
        {
?>
            <!-- /.row -->
            <div class="row">
                <div class="col-lg-12">
                    <div class="panel panel-default">
                        <div class="panel-heading">
                            <strong>Total Records Returned: <?php echo $TotalRecords; ?></strong>
                        </div>
                        <div class="panel-body">
                            <div>
<?php
                            if ($SearchErrors == true)
                            {
                                echo $NewRecordValidator->DisplayErrorsInTable();
                            }
?>
                                <div class="row" id="RecordTable">
                                    <div class="col-lg-12">
                                        <table width="100%" class="table table-striped table-bordered table-hover" id="DataTableRecords">
                                            <thead>
                                                <tr>
                                                    <th>S. No</th>
                                                    <th>Student Name (Roll No.)</th>
                                                    <th>Class</th>
                                                    <th>CC Issue Date</th>
                                                    <th>CharacterBehaviour</th>
                                                    <th>ExamnationSession</th>
                                                    <th class="text-center">Created By</th>
                                                    <th class="text-center">View</th> 
                                                    <th class="text-center">Delete</th> 
                                                </tr>
                                            </thead>
                                            <tbody>
<?php
                                    if (is_array($CCStudentsList) && count($CCStudentsList) > 0)
                                    {
                                        $Counter = 0;
                                        foreach ($CCStudentsList as $StudentTcDetailID => $CCDetails)
                                        {
?>
                                            <tr>
                                                <td><?php echo ++$Counter; ?></td>
                                                <td><?php echo $CCDetails['StudentName'] .' ( '. $CCDetails['RollNumber'] .' )'; ?></td>
                                                <td><?php echo $CCDetails['ClassName'] .' '. $CCDetails['SectionName']; ?></td>
                                                <td><?php echo (($CCDetails['CreateDate'] != '0000-00-00') ? date('d/m/Y', strtotime($CCDetails['CreateDate'])) : ''); ?></td>
                                                
                                                <td><?php echo $CCDetails['characterBehaviour']; ?></td>
                                                <td><?php echo $CCDetails['examnationSession']; ?></td>
                                                <td><?php echo $CCDetails['CreateUserName']; ?></td>
                                                <td class="text-center"><a href="certificate_formats/character_certificate.php?StudentID=<?php echo $CCDetails['StudentID']; ?>" target="_blank">View</a></td> 
                                                <td class="text-center"><a href="view_generated_Cc.php?Process=5&amp;StudentID=<?php echo $CCDetails['StudentID']; ?>" onclick="return confirm('Are you sure you want to delete this CC?');">Delete</a></td> 
                                            </tr>
<?php
                                        }
                                    }
?>
                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                            </div>
                            <!-- /.table-responsive -->
                        </div>
                        <!-- /.panel-body -->
                    </div>
                    <!-- /.panel -->
                </div>
                <!-- /.col-lg-12 -->
            </div>
<?php
        }
?>
        </div>
        <!-- /#page-wrapper -->

    </div>
    <!-- /#wrapper -->
<?php
require_once('../footer.php');
?>
<script src="../vendor/jquery-ui/jquery-ui.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/fancybox/3.5.2/jquery.fancybox.min.js"></script>
<script type="text/javascript">
$(document).ready(function()
{   
    $(".select-date").datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat: 'dd/mm/yy'
    });
    
	$('#Class').change(function()
    {
        var ClassID = parseInt($('#Class').val());
        
        if (ClassID <= 0)
        {
            $('#ClassSection').html('<option value="0">-- Select Section --</option>');
            return;
        }
        
        $.post("/xhttp_calls/get_sections_by_classs.php", {SelectedClassID:ClassID}, function(data)
        {
            ResultArray = data.split("|*****|");
            
            if (ResultArray[0] == 'error')
            {
                alert (ResultArray[1]);
                return false;
            }
            else
            {
                $('#ClassSection').html('<option value="0">-- Select Section --</option>' + ResultArray[1]);
            }
        });
    });

    $('#AllStudent').change(function(){
        if ($(this).prop("checked") == true)
        {
            $('.check-all-student').prop('checked',true);
        }
        else
        {
            $('.check-all-student').prop('checked',false);
        }
    });

    $('.check-all-student').change(function(){

        if ($(this).attr('anyDue') == 1 && $(this).prop("checked") == true)
        {
            if (!confirm('Are you really want to generate TC with out No-Dues.'))
            {
                $(this).prop('checked', false);
                return false;
            }
            else
            {
                var TotalStudent = <?php echo count($StudentsList);?>;
        
                if ($('input.check-all-student:checked').length == TotalStudent)
                {
                    $('#AllStudent').prop('checked', true);
                }
                else
                {
                    $('#AllStudent').prop('checked', false);
                }       
            }
        }
        else
        {
            var TotalStudent = <?php echo count($StudentsList);?>;
        
            if ($('input.check-all-student:checked').length == TotalStudent)
            {
                $('#AllStudent').prop('checked', true);
            }
            else
            {
                $('#AllStudent').prop('checked', false);
            }
        }
    });
});
</script>
</body>
</html>