<?php
require_once("../../../classes/class.users.php");
require_once("../../../classes/class.validation.php");
require_once("../../../classes/class.authentication.php");

require_once('../../../classes/school_administration/class.academic_years.php');
require_once("../../../classes/school_administration/class.students.php");
require_once("../../../classes/school_administration/class.parent_details.php");
require_once("../../../classes/school_administration/class.student_details.php");

require_once("../../../classes/school_administration/class.classes.php");
require_once("../../../classes/school_administration/class.section_master.php");
require_once("../../../classes/school_administration/class.class_sections.php");

require_once("../../../classes/class.date_processing.php");
require_once("../../../includes/global_defaults.inc.php");

//1. RECHECK IF THE USER IS VALID //
try
{
    $AuthObject = new ApplicationAuthentication;
    $LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}
catch (Exception $e)
{
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}
// END OF 1. //

if ($LoggedUser->HasPermissionForTask(TASK_EDIT_STUDENT) !== true)
{
	header('location:/admin/unauthorized_login_admin.php');
	exit;
}

$Clean = array();

$Clean['StudentID'] = 0;

if (isset($_GET['StudentID']))
{
    $Clean['StudentID'] = (int) $_GET['StudentID'];
}
elseif (isset($_POST['hdnStudentID']))
{
    $Clean['StudentID'] = (int) $_POST['hdnStudentID'];
}

if ($Clean['StudentID'] <= 0)
{
    header('location:../../error.php');
    exit;
}   

try
{
    $StudentObject = new StudentDetail($Clean['StudentID']);    
}
catch (ApplicationDBException $e)
{
    header('location:../../error.php');
    exit;
}
catch (Exception $e)
{
    header('location:../../error.php');
    exit;
}

//print_r($StudentObject);exit;

$HasErrors = false;

$AcademicYearID = 0;
$AcademicYearName = '';

$AcademicYearID = AcademicYear::GetCurrentAcademicYear($AcademicYearName);

$Clean['Process'] = 0;

$Clean['ClassSectionID'] = 0;
$Clean['ClassID'] = 0;
$Clean['Class'] = '';

$Clean['FirstName'] = '';
$Clean['LastName'] = '';

$Clean['DOB'] = '';
$Clean['Gender'] = '';

$Clean['Address1'] = '';
$Clean['Address2'] = '';

$Clean['FatherFirstName'] = '';
$Clean['FatherLastName'] = '';
$Clean['MotherFirstName'] = '';
$Clean['MotherLastName'] = '';

$SchoolName = '';
$AffilationDetails = 'Affiliated C.B.S.E Board New Delhi';
$Address = 'Tiloi Distt. Amethi (U.P.)';
$Pincode = 229309;
$City = 'Amethi';
$State = 'UP';
$ContactNumber = '0535-2634282';
$AffilationNumber = '2132953';


$SchoolName = 'PRITHVIRAJ CHAUHAN EDUCATION CENTRE';
$AffilationDetails = 'School No.54291';
$OtherDetails = 'Run Under Christian Community Educational Society, Sitapur';
$Address = 'Bhauti, Pratappur, Kanpur Nagar-224135';
$Affilation = '(Affilated to C.B.S.C. upto Sr.-Secondary Level)';
$City = 'SITAPUR';
$State = 'UP';
$ContactNumber = 'Phone No.0512-2696020,9936457167';
$AffilationNumber = '';

$Clean['ClassSectionID'] = $StudentObject->GetClassSectionID();

$ClassSectionDetails = new ClassSections($StudentObject->GetClassSectionID());

$ClassObject = new AddedClass($ClassSectionDetails->GetClassID());
$Clean['Class'] = $ClassObject->GetClassName();

$Clean['FirstName'] = $StudentObject->GetFirstName();
$Clean['LastName'] = $StudentObject->GetLastName();
$Clean['DOB'] = date('d/m/Y', strtotime($StudentObject->GetDOB()));
$Clean['Gender'] = $StudentObject->GetGender();        

$Clean['Address'] = $StudentObject->GetAddress1();

if ($Clean['Address'] == '') 
{
    $Clean['Address'] = $StudentObject->GetAddress2();         
}        

$Clean['AdmissionDate'] = date('d/m/Y', strtotime($StudentObject->GetAdmissionDate()));

$NewParentDetail = new ParentDetail($StudentObject->GetParentID());

$Clean['FatherFirstName'] = $NewParentDetail->GetFatherFirstName();
$Clean['FatherLastName'] = $NewParentDetail->GetFatherLastName();
$Clean['MotherFirstName'] = $NewParentDetail->GetMotherFirstName();
$Clean['MotherLastName'] = $NewParentDetail->GetMotherLastName();

require_once('../../html_header.php');
?>
<title>Character Certificate</title>
<link href="../../vendor/jquery-ui/jquery-ui.min.css" rel="stylesheet">
</head>

<body>

    <div id="wrapper">
        <!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
<?php 
            require_once('../../site_header.php');
            require_once('../../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">Character Certificate</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <strong>Character Certificate</strong>
                </div>
                <div class="panel-body">
                    <div>
                        <div class="row">
                            <div class="col-lg-6">                                     
                            </div>
                            <div class="col-lg-6">
                                <div class="print-btn-container"><button id="PrintButton" type="submit" class="btn btn-primary">Print</button></div>
                            </div>
                        </div>
                        <div id="RecordTableHeading">
                            <center>
                            <div class="align-center" style="position: relative; width:750px; height:600px; border:10px solid black; display:block; border-collapse: collapse;">
                                <div class="align-center" style="position: relative; border:3px solid gray; display:block; margin: 5px; height:570px;">

                                    <div style="height:100px; width:150px; margin-left:35px; float:left; margin-top:5px;">
                                        <img src="../../../site_images/school_logo/school_logo.jpg" height="70px;" width="80px;" style="margin-left:22px; margin-top:10px;" align="center;">
                                            <!--<br><strong><small>Affilation No: <?php echo $AffilationNumber; ?></small></strong>-->
                                    </div>
                                    
                                    <div style="height:100px; width:400px; float:left; margin-top:10px; text-align:center;">
                                        <strong style="font-size:25px;"><?php echo $SchoolName; ?></strong>
                                        <br><strong style="font-size:18px;"><?php echo $AffilationDetails; ?></strong>
                                        <br><strong style="font-size:15px;"><?php echo $Address .'Phone No. '. $ContactNumber; ?></strong>
                                    </div>
                                    <center>
                                        <div style="height:50px; width:320px; margin-top:170px; text-align:center; border:1px solid black; display:block; border-radius: 15px; box-shadow: 3px 5px;">
                                            <p style="font-family: cursive; font-size:20px; margin-top: 10px; text-shadow: 0 0 1px;"><i>CHARACTER CERTIFICATE</i></p>
                                        </div>
                                    </center>
                                    <div style="margin-top: 30px; margin-left: 10px;">
                                        <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;">Certified that <span style="border-bottom: 1px dotted #000; text-decoration: none; width: 510px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['FirstName'] .' '. $Clean['LastName'] ;?></b></span></p>

                                        <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;"> S/o, D/o Mr.&nbsp; <span style="border-bottom: 1px dotted #000; text-decoration: none; width: 506px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['FatherFirstName'] .' '. $Clean['FatherLastName'] ;?></b></span></p>

                                        <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 10px; display: flex;">Address <span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 550px; "><b>&nbsp;&nbsp;&nbsp;<?php echo $Clean['Address'] ;?></b></span></p>

                                        <p style="font-family: cursive; font-size:18px;  margin-top: 10px; display: flex;"> is studying in class <span class="unique-function" style="font-family: cursive; font-size:17px; border-bottom: 1px dotted #000; text-decoration: none; width: 110px; "><b>&nbsp;&nbsp;<?php echo $Clean['Class'] ;?></b></span> in this institution from <span class="unique-function" style="font-family: normal; font-size:17px; border-bottom: 1px dotted #000; text-decoration: none; width: 110px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['AdmissionDate'] ;?></b></span>to <span class="unique-function" style="font-family: normal; font-size:17px; border-bottom: 1px dotted #000; text-decoration: none; width: 90px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $AcademicYearName ;?></b></span></p>

                                        <p style="font-family: cursive; font-size:18px; font-weight: 22px; margin-top: 25px; display: flex;"> To the best of my knowledge & belief he/she bears a good moral character. </p>
                                        <p style="font-family: cursive; font-size:18px; display: flex;"> I wish him/her success in life. </p>

                                    </div>
                                    <div style="margin-top: 45px; margin-left: 20px;">
                                        <div style="font-family: cursive; font-size:18px; float: left; font-weight: 22px; margin-top: 10px; display: flex;"> Date: </div>
                                        <div style="font-family: cursive; font-size:18px; float: right; font-weight: 22px; margin-top: 10px; margin-right: 70px; display: flex;"> Principal </div>
                                    </div>
                                </div>
                            </div>
                            </center>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <!-- /#page-wrapper -->

    </div>
    <!-- /#wrapper -->
<?php
require_once('../../footer.php');
?>
<script src="../../js/print-report.js"></script>
<script type="text/javascript">
    $(document).ready(function () {
        $('.unique-function').click(function () {

            var DataValue = prompt('Enter Details', $(this).text().trim());
            if (DataValue)
            {
                $(this).html('&nbsp;&nbsp;<b>' + DataValue + '</b>');
            }
        });
    });
</script>
</body>
</html>