<?php
require_once("../../../classes/class.users.php");
require_once("../../../classes/class.validation.php");
require_once("../../../classes/class.authentication.php");

require_once('../../../classes/school_administration/class.academic_years.php');
require_once("../../../classes/school_administration/class.students.php");
require_once("../../../classes/school_administration/class.parent_details.php");
require_once("../../../classes/school_administration/class.student_details.php");

require_once("../../../classes/school_administration/class.classes.php");
require_once("../../../classes/school_administration/class.section_master.php");
require_once("../../../classes/school_administration/class.class_sections.php");

require_once('../../../classes/school_administration/class.student_tc_details.php');

require_once("../../../classes/class.convert_number_to_words.php");
require_once("../../../classes/class.date_processing.php");
require_once("../../../includes/global_defaults.inc.php");

//1. RECHECK IF THE USER IS VALID //
try
{
    $AuthObject = new ApplicationAuthentication;
    $LoggedUser = new User(0, $AuthObject->CheckValidUser());
}

// THIS CATCH BLOCK BUBBLES THE EXCEPTION TO THE BUILT IN 'Exception' CLASS IF THERE ARE ANY UNCAUGHT ERRORS //
catch (ApplicationAuthException $e)
{
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}
catch (Exception $e)
{
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}
// END OF 1. //

if ($LoggedUser->HasPermissionForTask(TASK_EDIT_STUDENT) !== true)
{
    header('location:/admin/unauthorized_login_admin.php');
    exit;
}

$HasErrors = false;

$AcademicYearID = 0;
$AcademicYearName = '';

$AcademicYearID = AcademicYear::GetCurrentAcademicYear($AcademicYearName);

$SchoolName = 'PRITHVIRAJ CHAUHAN EDUCATION CENTRE';
$AffilationDetails = 'School No.54291';
$OtherDetails = 'Run Under Christian Community Educational Society, Sitapur';
$Address = 'Bhauti, Pratappur, Kanpur Nagar-224135';
$Affilation = 'Affilated to C.B.S.E. (Affilation #: 2131190)';
$ContactNumber = 'Phone No. 8853942696, 7097542696';
$AffilationNumber = '';

$Clean = array();

$Clean['Process'] = 0;

$Clean['Blank'] = '';

$Clean['ClassSectionID'] = 0;
$Clean['ClassID'] = 0;
$Clean['Class'] = '';
$Clean['ClassInWords'] = '';

$Clean['FirstName'] = '';
$Clean['LastName'] = '';

$Clean['DOB'] = '';
$Clean['SubjectsProposed'] = '';

$Clean['DOBInWords'] = '';
$Clean['Gender'] = '';

$Clean['Address1'] = '';
$Clean['Address2'] = '';

$Clean['Religion'] = '';
$Clean['Category'] = '';
$Clean['BloodGroup'] = '';
$Clean['AdmissionDate'] = '';
$Clean['AdmissionClass'] = '';

$Clean['FatherFirstName'] = '';
$Clean['FatherLastName'] = '';
$Clean['MotherFirstName'] = '';
$Clean['MotherLastName'] = '';

$Clean['TCNumber'] = '';

$Clean['RegistrationNo'] = '';
$Clean['LastClassExamResult'] = '';
$Clean['PromotedToHigherClass'] = '';
$Clean['AnyFeeConcession'] = '';
$Clean['NoOfMeeting'] = '';

$Clean['PaidAllDues'] = '';
$Clean['TotalPresentDays'] = '';

$Clean['ResultStatus'] = '';
$Clean['NccCadet'] = '';
$Clean['GeneralConduct'] = 'Satisfactory';
$Clean['LastDateOfSession'] = '';
$Clean['TcIssueDate'] = '';
$Clean['LeavingDate'] = '';
$Clean['StuckOffClass'] = '';
$Clean['ReasonOfLeaving'] = '';
$Clean['NoOfWorkingDays'] = '';
$Clean['OtherRemark'] = '';

$Clean['SelectedStudents'] = '';
$Clean['ClassSectionID'] = 0;

if (isset($_GET['SelectedStudents']))
{
    $Clean['SelectedStudents'] = (string) $_GET['SelectedStudents'];
}

if ($Clean['SelectedStudents'] == '')
{
    header('location:admin/error.php');
    exit;
}

if (isset($_GET['ClassSectionID']))
{
    $Clean['ClassSectionID'] = (int) $_GET['ClassSectionID'];
}

// if ($Clean['ClassSectionID'] <= 0)
// {
//     header('location:admin/error.php');
//     exit;
// }

$Clean['SelectedStudentList'] = explode(',', $Clean['SelectedStudents']);

require_once('../../html_header.php');
?>
<title>Transfer Certificate</title>
<link href="../../vendor/jquery-ui/jquery-ui.min.css" rel="stylesheet">
  <link rel="stylesheet" href="//code.jquery.com/ui/1.12.1/themes/base/jquery-ui.css">
<style>
    label, input { display:block; }
    input.text { margin-bottom:12px; width:95%; padding: .4em; }
    fieldset { padding:0; border:0; margin-top:25px; }
    h1 { font-size: 1.2em; margin: .6em 0; }
    div#users-contain { width: 350px; margin: 20px 0; }
    div#users-contain table { margin: 1em 0; border-collapse: collapse; width: 100%; }
    div#users-contain table td, div#users-contain table th { border: 1px solid #eee; padding: .6em 10px; text-align: left; }
    .ui-dialog .ui-state-error { padding: .3em; }
    .validateTips { border: 1px solid transparent; padding: 0.3em; }
  </style>
</head>

<body>

    <div id="wrapper">
        <!-- Navigation -->
        <nav class="navbar navbar-default navbar-static-top" role="navigation" style="margin-bottom: 0">
<?php 
            require_once('../../site_header.php');
            require_once('../../left_navigation_menu.php');
?>                    
            <!-- /.navbar-static-side -->
        </nav>

        <div id="page-wrapper">
            <div class="row">
                <div class="col-lg-12">
                    <h1 class="page-header">Transfer Certificate</h1>
                </div>
                <!-- /.col-lg-12 -->
            </div>
            <div class="panel panel-default">
                <div class="panel-heading">
                    <strong>Transfer Certificate</strong>
                </div>
                <div class="panel-body">
                    <div>
                        <div class="row">
                            <div class="col-lg-6">                                     
                            </div>
                            <div class="col-lg-6">
                                <div class="print-btn-container"><button id="PrintButton" type="submit" class="btn btn-primary">Print</button></div>
                            </div>
                        </div>
                        <div class="row" id="RecordTableHeading" style="page-break-before: always;">
<?php

                            foreach ($Clean['SelectedStudentList'] as $key => $StudentID) 
                            {
                                try
                                {
                                    $CurrentStudent = new StudentDetail($StudentID); 
                                    $CurrentParent = new ParentDetail($CurrentStudent->GetParentID()); 
                                    
                                    $CurrentClassSections = new ClassSections($CurrentStudent->GetClassSectionID());
                                    $CurrentClass = new AddedClass($CurrentClassSections->GetClassID());
                                    
                                    $Clean['ClassSectionID'] = $CurrentStudent->GetClassSectionID();
                                    $Clean['Class'] = $CurrentClass->GetClassName();
                                    $Clean['ClassID'] = $CurrentClassSections->GetClassID();
                                    
                                    if (is_numeric($Clean['Class']))
                                    {
                                        $Clean['ClassInWords'] = NumberConvert::convertNumber($Clean['Class']);
                                    }
                                    else
                                    {
                                        $Clean['ClassInWords'] = $Clean['Class'];
                                    }
                            
                                    $Clean['FirstName'] = $CurrentStudent->GetFirstName();
                                    $Clean['LastName'] = $CurrentStudent->GetLastName();
                                    $Clean['DOB'] = date('d/m/Y', strtotime($CurrentStudent->GetDOB()));
                                    $Clean['SubjectsProposed'] = $CurrentStudent->GetSubjectsProposed();
                                    
                                    // start code fro convert date in to words
                                    
                                    $NewDob = explode('-', $CurrentStudent->GetDOB());
                                    
                                    $Year = $NewDob[0];
                                    $Month = $NewDob[1];
                                    $Day  = $NewDob[2];
                                    
                                    $BirthDay = NumberConvert::convertNumber($Day);
                                    $BirthYear = NumberConvert::convertNumber($Year);
                                    $MonthNumber = $Month;
                                    
                                    $DateObj = DateTime::createFromFormat('!m', $MonthNumber);//Convert the number into month name
                                    $MonthName = $DateObj->format('F');
                                    
                                    $Clean['DOBInWords'] = $BirthDay .' '. $MonthName .' '. $BirthYear;
                                    
                                    // end code fro convert date in to words
                                    
                                    $Clean['Gender'] = $CurrentStudent->GetGender();        
                                    $Clean['EnrollmentID'] = $CurrentStudent->GetEnrollmentID();        
                                    $Clean['Category'] = $CurrentStudent->GetCategory();        
                                    $Clean['BloodGroup'] = $CurrentStudent->GetBloodGroup();        
                                    
                                    if ($Clean['ClassID'] > 8 && $Clean['Gender'] == 'Female')
                                    {
                                        $Clean['NccCadet'] = 'Girl Guide';
                                    }
                                    
                                    $Clean['Address'] = $CurrentStudent->GetAddress1();
                            
                                    if ($Clean['Address'] == '') 
                                    {
                                        $Clean['Address'] = $CurrentStudent->GetAddress2();         
                                    }        
                                    
                                    if ($CurrentStudent->GetAdmissionDate() != '0000-00-00')
                                    {
                                        $Clean['AdmissionDate'] = date('d/m/Y', strtotime($CurrentStudent->GetAdmissionDate()));    
                                    }
                                    
                                    $Clean['AdmissionClass'] = $CurrentStudent->GetLastClass();
                                    // $Clean['Religion'] = $CurrentStudent->GetReligion();
                                   
                                    $CurrentParent = new ParentDetail($CurrentStudent->GetParentID());
                            
                                    $Clean['FatherFirstName'] = $CurrentParent->GetFatherFirstName();
                                    $Clean['FatherLastName'] = $CurrentParent->GetFatherLastName();
                                    $Clean['MotherFirstName'] = $CurrentParent->GetMotherFirstName();
                                    $Clean['MotherLastName'] = $CurrentParent->GetMotherLastName();
                                    
                                    $StudentTCDetails = array();
                                    $StudentTCDetails = StudentTcDetail::GetStudentTCDetails($StudentID);
                                    
                                    if (count($StudentTCDetails) > 0)
                                    {
                                        $Clean['RegistrationNo'] = $StudentTCDetails[$StudentID]['RegistrationNo'];
                                        $Clean['LastClassExamResult'] = $StudentTCDetails[$StudentID]['LastClassExamResult'];
                                        $Clean['PromotedToHigherClass'] = $StudentTCDetails[$StudentID]['PromotedToHigherClass'];
                                        $Clean['AnyFeeConcession'] = $StudentTCDetails[$StudentID]['AnyFeeConcession'];
                                        $Clean['NoOfMeeting'] = $StudentTCDetails[$StudentID]['NoOfMeeting'];

                                        $Clean['PaidAllDues'] = $StudentTCDetails[$StudentID]['PaidAllDues'];
                                        $Clean['TotalPresentDays'] = $StudentTCDetails[$StudentID]['TotalPresentDays'];

                                        $Clean['TCNumber'] = $StudentTCDetails[$StudentID]['TCNumber'];
                                        
                                        $Clean['ResultStatus'] = $StudentTCDetails[$StudentID]['ResultStatus'];
                                        $Clean['NccCadet'] = $StudentTCDetails[$StudentID]['NccCadet'];
                                        $Clean['GeneralConduct'] = $StudentTCDetails[$StudentID]['GeneralConduct'];
                                        
                                        if ($StudentTCDetails[$StudentID]['LastDateOfSession'] != '0000-00-00')
                                        {
                                            $Clean['LastDateOfSession'] = date('d/m/Y', strtotime($StudentTCDetails[$StudentID]['LastDateOfSession']));    
                                        }
                                        
                                        if ($StudentTCDetails[$StudentID]['TcIssueDate'] != '0000-00-00')
                                        {
                                            $Clean['TcIssueDate'] = date('d/m/Y', strtotime($StudentTCDetails[$StudentID]['TcIssueDate']));    
                                        }
                                        
                                        if ($StudentTCDetails[$StudentID]['LeavingDate'] != '0000-00-00')
                                        {
                                            $Clean['LeavingDate'] = date('d/m/Y', strtotime($StudentTCDetails[$StudentID]['LeavingDate']));    
                                        }
                                        
                                        $Clean['StuckOffClass'] = $StudentTCDetails[$StudentID]['StuckOffClass'];
                                        $Clean['ReasonOfLeaving'] = $StudentTCDetails[$StudentID]['ReasonOfLeaving'];
                                        $Clean['NoOfWorkingDays'] = $StudentTCDetails[$StudentID]['NoOfWorkingDays'];
                                        $Clean['OtherRemark'] = $StudentTCDetails[$StudentID]['OtherRemark'];
                                    }
                                }
                                catch (ApplicationDBException $e)
                                {
                                    header('location:admin/error.php');
                                    exit;
                                }
                                catch (Exception $e)
                                {
                                    header('location:admin/error.php');
                                    exit;
                                }
                                
?>
                                <div class="align-center" style="position: relative; width:740px; height:1060px; border:1px solid grey; display:block;">
                                    <div style="height:70px; width:130px; margin-left:10px; float:left; margin-top:5px;">
                                        <img src="../../../site_images/school_logo/school_logo.jpg"" height="100px;" width="120px;" style="margin-left:12px; margin-top:0px;" align="center;">
                                    </div>
                                    <div style="margin-right: 8px;
                                                font-weight: bold;
                                                float: right;">
                                                School No.: 70772
                                    </div>
                                    <div style="height:70px; width:550px; float:left; margin-left:10px; margin-top:10px; text-align:center;">
                                        <strong style="font-size:18px;"><?php echo $SchoolName; ?></strong>
                                        <br><strong style="font-size:12px;"><?php echo $Address; ?></strong>
                                        <br><strong style="font-size:12px;"><?php echo $Affilation; ?></strong>
                                        <br><strong style="font-size:12px;"><?php echo $ContactNumber ; ?></strong>
                                        <!--<br><strong style="font-size:12px;"><?php echo $AffilationDetails; ?></strong>-->
                                    </div>
                                    <center>
                                        <div style="height:20px; width:340px; margin-top:120px; text-align:center; border:1px solid black; display:block; border-radius: 5px;margin-left:50px;box-shadow: 1px 2px;">
                                              <p style=" font-size:12px;">TRANSFER CERTIFICATE</p>
                                        </div>
                                    </center>
                                    <div style="margin-top: 15px; margin-left: 10px;font-size: 10px;">
                                        <p style="font-family: normal; margin-top: 10px; display: flex;">
                                        <span style="">Book No : </span><span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 60px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['EnrollmentID'] ;?></b></span>
                                        &nbsp;&nbsp;<span style="margin-left: 125px;">S.R. No : </span><span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 60px;" id="TCNumber<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['TCNumber'] ;?></b></span>
                                         &nbsp;&nbsp;<span style="margin-left: 102px;">Admission No : </span><span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 160px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['EnrollmentID'] ;?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 4px;"></strong>Registraion No.of the candidate(in case Class-IX to XII) :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 420px; margin-left: 5px;" studentID="<?php echo $StudentID;?>" id="RegistrationNo<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['RegistrationNo'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">1.</strong>Name of the Pupil :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 490px; margin-left: 15px;" id="StudentName<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['FirstName'] .' '. $Clean['LastName'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">2.</strong>Mother's Name :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 510px; margin-left: 15px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['MotherFirstName'] .' '. $Clean['MotherLastName'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">3.</strong>Father's/Guardian's Name :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 470px; margin-left: 15px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['FatherFirstName'] .' '. $Clean['FatherLastName'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong style="margin-right: 10px;">4.</strong>Nationality :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 545px; margin-left: 15px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo 'Indian';?></b></span></p>
                                        <p style="font-family: normal; margin-top: 2px; display: flex;">
                                            <strong>5.</strong>
                                            <strong style="margin-right: 10px;"></strong>Whether the pupil belongs to SC/ST/OBC/General/Other Category :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 425px; margin-left: 10px;"><b><?php echo $Clean['Category'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;margin-bottom: 2px;"><strong style="margin-right: 10px;">6.</strong>Date of Birth According to the Admission Register(in figure) :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none;width: 130px; "><b><?php echo $Clean['DOB'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 2px; display: flex;margin-left: 15px;">(in words)
                                        <span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width:560px; margin-left: 15px;"><b><?php echo $Clean['DOBInWords'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 2px; display: flex;">
                                        <strong>7.</strong>
                                        <strong style="margin-right: 10px;"></strong>Whether the student is failed:<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 515px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="ResultStatus<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['ResultStatus'];?></b></span></p>
                                         <p style="font-family: normal; margin-top: 10px; display: flex;">
                                         <strong style="margin-right: 10px;">8.</strong>Subject Offered:<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 505px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="SubjectsProposed<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['SubjectsProposed'];?></b></span></p>
                                         <p style="font-family: normal; margin-top: 2px; display: flex;">
                                        
                                        <!--<strong>9.</strong>-->
                                        <!-- <strong style="margin-right: 10px;"></strong>Class in which the pupil last studied(in words) : <span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 455px; "><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['ClassInWords'] ;?></b></span></p>-->
                                        <!--<p style="font-family: normal; margin-top: 10px; display: flex;">-->
                                        
                                        <strong style="margin-right: 10px;">9.</strong>School/Board Annual Examination last taken with result :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 255px;" studentID="<?php echo $StudentID;?>" id="LastClassExamResult<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['LastClassExamResult'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 2px; display: flex;">
                                        <strong>10.</strong>
                                        <strong style="margin-right: 10px;"></strong>Whether qualified for promotion to the next higher class:<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 400px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="PromotedToHigherClass<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['PromotedToHigherClass'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 2px; display: flex;">
                                        <strong>11.</strong>
                                        <strong style="margin-right: 10px;"></strong>Whether the pupil has paid all dues to the School:<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 430px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="PaidAllDues<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['PaidAllDues'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 2px; display: flex;">
                                        <!--<strong>12.</strong>-->
                                        <!--<strong style="margin-right: 10px;"></strong>Whether the pupil was in receipt of any fee concession,if so the nature of such concession:<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 270px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="AnyFeeConcession<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['AnyFeeConcession'];?></b></span></p>-->
                                        <!--<p style="font-family: normal; margin-top: 2px; display: flex;">-->
                                        <!--<strong>14.</strong>-->
                                        <!--<strong style="margin-right: 10px;"></strong>Whether the pupil was in <?php echo ($Clean['ClassID'] > 8) ? 'Girl Guide/Boy Scout' : 'NCC Cadet/Boy Scout/Girl Guide(Give details)' ;?> :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 330px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="NccCadet<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['NccCadet'];?></b></span></p>-->
                                        <!--<p style="font-family: normal; margin-top: 2px; display: flex;">-->
                                        <strong>12.</strong>
                                        <strong style="margin-right: 10px;"></strong>Date of admission & class of pupil in school:<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 460px; margin-left: 15px;"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['AdmissionDate'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 2px; display: flex;">
                                        <strong>13.</strong>
                                        <strong style="margin-right: 10px;"></strong>Date & class on which pupil's name was stuck off the rolls of the School :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 60px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="LeavingDate<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['LeavingDate'];?></b></span><span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 300px; margin-left: 1px;" studentID="<?php echo $StudentID;?>" id="StuckOffClass<?php echo $StudentID;?>"><b><?php echo $Clean['StuckOffClass'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;">
                                        <strong>14.</strong><strong style="margin-right: 10px;"></strong>Reason for leaving the school :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 400px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="ReasonOfLeaving<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['ReasonOfLeaving'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong>15.</strong><strong style="margin-right: 10px;"></strong>Total number of working days :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 342px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="NoOfWorkingDays<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['NoOfWorkingDays'];?></b></span></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong>16.</strong><strong style="margin-right: 10px;"></strong>No. of school days the pupil attended :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 280px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="TotalPresentDays<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['TotalPresentDays'];?></b></span></p>
                                         <p style="font-family: normal; margin-top: 10px; display: flex;"><strong>17.</strong><strong style="margin-right: 10px;"></strong>General conduct and character :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 430px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="GeneralConduct<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['GeneralConduct'];?></b></span></p>
                                        
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong>18.</strong><strong style="margin-right: 10px;"></strong>Date of issue of transfer certificate :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 370px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="TcIssueDate<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['TcIssueDate'];?></b></span></p></p>
                                        <p style="font-family: normal; margin-top: 10px; display: flex;"><strong>19.</strong><strong style="margin-right: 10px;"></strong>Any other remarks :<span class="unique-function" style="border-bottom: 1px dotted #000; text-decoration: none; width: 470px; margin-left: 15px;" studentID="<?php echo $StudentID;?>" id="OtherRemark<?php echo $StudentID;?>"><b>&nbsp;&nbsp;&nbsp;&nbsp;<?php echo $Clean['OtherRemark'];?></b></span></p>
                                    </div>
                                    <div style="margin-top: 30px; margin-left: 20px;">
                                        <div style="font-family: normal; font-size:12px; float: left; font-weight: 22px; margin-top: 10px; display: flex; border-top: 1px solid black;">Prepared by<br> (Name & Designation)</div>
                                         <div style="font-family: normal; font-size:12px; float: left; font-weight: 22px; margin-top: 10px; display: flex; border-top: 1px solid black;margin-left: 155px;">Checked by<br> (Name & Designation)</div>
                                        <div style="font-family: normal; font-size:12px; float: right; font-weight: 22px; margin-top: 10px; margin-right: 60px; display: flex; border-top: 1px solid black;">&nbsp;&nbsp;&nbsp;&nbsp;Sign.of. Principal with Official Seal <br></div>
                                    </div>
                                    <div style="margin-top: 100px;margin-left: 10px;font-size: 10px;">
                                        <b>Note:-</b>If this TC is issued by the Officiating/incharge Principal,variably countersigned by the Manager-V.M.C.  
                                    </div> 
                                </div>
                                <div style="page-break-after: always;"></div>
<?php
                            }
?>
                        </div>
                        
                    </div>
                </div>
            </div>
        </div>
        <!-- /#page-wrapper -->

<div id="dialog-form" title="Edit TC Details">
  <p class="validateTips">Please fill other details for TC of <u><b><span id="StudentName"></span></b></u>.</p>
 
  <form>
    <fieldset>
      <label for="RegistrationNo">Registration Number of the candidate</label>
      <input type="text" name="RegistrationNo" id="RegistrationNo" value="" class="text ui-widget-content ui-corner-all">

      <label for="LastClassExamResult">School/Board Annual Examination last taken with result</label>
      <input type="text" name="LastClassExamResult" id="LastClassExamResult" value="" class="text ui-widget-content ui-corner-all">

      <label for="PromotedToHigherClass">Promoted To Higher class </label>
      <input type="text" name="PromotedToHigherClass" id="PromotedToHigherClass" value="" class="text ui-widget-content ui-corner-all">

       <label for="AnyFeeConcession">Any Fee concession</label>
       <input type="text" name="AnyFeeConcession" id="AnyFeeConcession" value="" class="text ui-widget-content ui-corner-all">

       <label for="NoOfMeeting">Number of meeting</label>
      <input type="text" name="NoOfMeeting" id="NoOfMeeting" value="" class="text ui-widget-content ui-corner-all">

      <label for="PaidAllDues">Paid All Dues</label>
      <input type="text" name="PaidAllDues" id="PaidAllDues" value="" class="text ui-widget-content ui-corner-all">

      <label for="TotalPresentDays">Total Present Days</label>
      <input type="text" name="TotalPresentDays" id="TotalPresentDays" value="" class="text ui-widget-content ui-corner-all">

      <label for="ResultStatus">Whether the student is failed </label>
      <input type="text" name="ResultStatus" id="ResultStatus" value="" class="text ui-widget-content ui-corner-all">
      
      <input type="hidden" name="TCNumber" id="TCNumber" value="">
      <input type="hidden" name="StudentID" id="StudentID" value="">
      
      <label for="GeneralConduct">General Conduct</label>
      <input type="text" name="GeneralConduct" id="GeneralConduct" value="" class="text ui-widget-content ui-corner-all">
      
      <label for="LastDateOfSession">Last Date Of Session</label>
      <input type="text" name="LastDateOfSession" id="LastDateOfSession" value="" class="text ui-widget-content ui-corner-all select-date">
      
      <label for="TcIssueDate">Tc Issue Date</label>
      <input type="text" name="TcIssueDate" id="TcIssueDate" value="" class="text ui-widget-content ui-corner-all select-date">
      
      <label for="LeavingDate">Leaving Date</label>
      <input type="text" name="LeavingDate" id="LeavingDate" value="" class="text ui-widget-content ui-corner-all select-date">
      
      <label for="StuckOffClass">Stuck Off Class</label>
      <input type="text" name="StuckOffClass" id="StuckOffClass" value="" class="text ui-widget-content ui-corner-all">
      
      <label for="ReasonOfLeaving">Reason Of Leaving</label>
        <select name="ReasonOfLeaving" id="ReasonOfLeaving" class="ui-widget-content ui-corner-all" style="margin-bottom:12px; width: 95%; height:30px; padding:.4em;">
          <option value="Parent`s wish">Parent`s wish</option>
          <option value="Parent transfered">Parent transfered</option>
          <option value="Last class passed">Last class passed</option>
          <option value="Other">Other</option>
        </select>
        
        <!--<input type="text" name="ReasonOfLeaving" id="ReasonOfLeaving" value="" class="text ui-widget-content ui-corner-all">-->
        
        <label for="NoOfWorkingDays">Number of working days</label>
      <input type="text" name="NoOfWorkingDays" id="NoOfWorkingDays" value="" class="text ui-widget-content ui-corner-all">
      
      <label for="OtherRemark">Other Remark</label>
      <input type="text" name="OtherRemark" id="OtherRemark" value="" class="text ui-widget-content ui-corner-all">
      
      <!-- Allow form submission with keyboard without duplicating the dialog button -->
      <input type="submit" tabindex="-1" style="position:absolute; top:-1000px">
    </fieldset>
  </form>
</div>
    </div>
    <!-- /#wrapper -->
<?php
require_once('../../footer.php');
?>
<script src="https://code.jquery.com/ui/1.12.1/jquery-ui.js"></script>
<script src="../../js/print-report.js"></script>
<script type="text/javascript">
$(document).ready(function () {
    $(".select-date").datepicker({
        changeMonth: true,
        changeYear: true,
        dateFormat: 'dd/mm/yy'
    });
    
    $('.unique-function').click(function () {
        
        if ($(this).attr('studentID') )
        {
            var StudentID = $(this).attr('studentID');
            
            $('#StudentID').val(StudentID);
            $('#TCNumber').val($('#TCNumber'+StudentID).text().trim());
            $('#StudentName').text($('#StudentName'+StudentID).text().trim());

            $('#RegistrationNo').val($('#RegistrationNo'+StudentID).text().trim());
            $('#LastClassExamResult').val($('#LastClassExamResult'+StudentID).text().trim());
            $('#PromotedToHigherClass').val($('#PromotedToHigherClass'+StudentID).text().trim());
            $('#AnyFeeConcession').val($('#AnyFeeConcession'+StudentID).text().trim());
            $('#NoOfMeeting').val($('#NoOfMeeting'+StudentID).text().trim());

            $('#PaidAllDues').val($('#PaidAllDues'+StudentID).text().trim());
            $('#TotalPresentDays').val($('#TotalPresentDays'+StudentID).text().trim());

            $('#ResultStatus').val($('#ResultStatus'+StudentID).text().trim());
            $('#NccCadet').val($('#NccCadet'+StudentID).text().trim());
            $('#GeneralConduct').val($('#GeneralConduct'+StudentID).text().trim());
            $('#LastDateOfSession').val($('#LastDateOfSession'+StudentID).text().trim());
            $('#TcIssueDate').val($('#TcIssueDate'+StudentID).text().trim());
            $('#LeavingDate').val($('#LeavingDate'+StudentID).text().trim());
            $('#StuckOffClass').val($('#StuckOffClass'+StudentID).text().trim());
            $('#ReasonOfLeaving').val($('#ReasonOfLeaving'+StudentID).text().trim());
            $('#NoOfWorkingDays').val($('#NoOfWorkingDays'+StudentID).text().trim());
            $('#OtherRemark').val($('#OtherRemark'+StudentID).text().trim());
            
            dialog.dialog( "open" );
        }
        else
        {
            var DataValue = prompt('Enter Details', $(this).text().trim());
            if (DataValue)
            {
                $(this).html('&nbsp;&nbsp;<b>' + DataValue + '</b>');
            }    
        }
    });
    
    function SaveTcDetails()
    {
        var TCNumber = '';
        var StudentID = '';
        
        var ResultStatus = '';

        var RegistrationNo = '';
        var LastClassExamResult = '';
        var PromotedToHigherClass = '';
        var AnyFeeConcession = '';
        var NoOfMeeting = '';

        var PaidAllDues = '';
        var TotalPresentDays = '';

        var NccCadet = '';
        var GeneralConduct = '';
        var LastDateOfSession = '';
        var TcIssueDate = '';
        var LeavingDate = '';
        var StuckOffClass = '';
        var ReasonOfLeaving = '';
        var NoOfWorkingDays = '';
        var OtherRemark = '';

        TCNumber = $('#TCNumber').val();
        StudentID = $('#StudentID').val();
        
        RegistrationNo = $('#RegistrationNo').val();
        LastClassExamResult = $('#LastClassExamResult').val();
        PromotedToHigherClass = $('#PromotedToHigherClass').val();
        AnyFeeConcession = $('#AnyFeeConcession').val();
        NoOfMeeting = $('#NoOfMeeting').val();

        PaidAllDues = $('#PaidAllDues').val();
        TotalPresentDays = $('#TotalPresentDays').val();

        ResultStatus = $('#ResultStatus').val();
        NccCadet = $('#NccCadet').val();
        GeneralConduct = $('#GeneralConduct').val();
        LastDateOfSession = $('#LastDateOfSession').val();
        TcIssueDate = $('#TcIssueDate').val();
        LeavingDate = $('#LeavingDate').val();
        StuckOffClass = $('#StuckOffClass').val();
        ReasonOfLeaving = $('#ReasonOfLeaving').val();
        NoOfWorkingDays = $('#NoOfWorkingDays').val();
        OtherRemark = $('#OtherRemark').val();
    
        if (TCNumber == '' || StudentID == '') 
        {
            alert('Unknown error, please try again.');
            return false;
        }

        $.post("/xhttp_calls/update_student_tc_details.php", {TCNumber:TCNumber, StudentID:StudentID, RegistrationNo:RegistrationNo, LastClassExamResult:LastClassExamResult, PromotedToHigherClass:PromotedToHigherClass, AnyFeeConcession:AnyFeeConcession, NoOfMeeting:NoOfMeeting, PaidAllDues:PaidAllDues, TotalPresentDays:TotalPresentDays, ResultStatus:ResultStatus, NccCadet:NccCadet, GeneralConduct:GeneralConduct, LastDateOfSession:LastDateOfSession, TcIssueDate:TcIssueDate, LeavingDate:LeavingDate, StuckOffClass:StuckOffClass, ReasonOfLeaving:ReasonOfLeaving, NoOfWorkingDays:NoOfWorkingDays, OtherRemark:OtherRemark}, function(data)
        {
            ResultArray = data.split("|*****|");
            
            if (ResultArray[0] == 'error')
            {
                alert (ResultArray[1]);
                return false;
            }
            else
            {   
                $('#RegistrationNo'+StudentID).html('&nbsp;&nbsp;<b>' + RegistrationNo + '</b>');
                $('#LastClassExamResult'+StudentID).html('&nbsp;&nbsp;<b>' + LastClassExamResult + '</b>');
                $('#PromotedToHigherClass'+StudentID).html('&nbsp;&nbsp;<b>' + PromotedToHigherClass + '</b>');
                $('#AnyFeeConcession'+StudentID).html('&nbsp;&nbsp;<b>' + AnyFeeConcession + '</b>');
                $('#NoOfMeeting'+StudentID).html('&nbsp;&nbsp;<b>' + NoOfMeeting + '</b>');

                $('#PaidAllDues'+StudentID).html('&nbsp;&nbsp;<b>' + PaidAllDues + '</b>');
                $('#TotalPresentDays'+StudentID).html('&nbsp;&nbsp;<b>' + TotalPresentDays + '</b>');

                $('#ResultStatus'+StudentID).html('&nbsp;&nbsp;<b>' + ResultStatus + '</b>');
                $('#NccCadet'+StudentID).html('&nbsp;&nbsp;<b>' + NccCadet + '</b>');
                $('#GeneralConduct'+StudentID).html('&nbsp;&nbsp;<b>' + GeneralConduct + '</b>');
                $('#LastDateOfSession'+StudentID).html('&nbsp;&nbsp;<b>' + LastDateOfSession + '</b>');
                $('#TcIssueDate'+StudentID).html('&nbsp;&nbsp;<b>' + TcIssueDate + '</b>');
                $('#LeavingDate'+StudentID).html('&nbsp;&nbsp;<b>' + LeavingDate + '</b>');
                $('#StuckOffClass'+StudentID).html('&nbsp;&nbsp;<b>' + StuckOffClass + '</b>');
                $('#ReasonOfLeaving'+StudentID).html('&nbsp;&nbsp;<b>' + ReasonOfLeaving + '</b>');
                $('#NoOfWorkingDays'+StudentID).html('&nbsp;&nbsp;<b>' + NoOfWorkingDays + '</b>');
                $('#OtherRemark'+StudentID).html('&nbsp;&nbsp;<b>' + OtherRemark + '</b>');
                
                dialog.dialog( "close" );
            }
        });
    }
    
    dialog = $( "#dialog-form" ).dialog({
      autoOpen: false,
      height: 600,
      width: 450,
      modal: true,
      position: { my: "right top", at: "right top", of: window },
      buttons: {
        "Save ": SaveTcDetails,
        Cancel: function() {
          dialog.dialog( "close" );
        }
      },
      close: function() {
        form[ 0 ].reset();
      }
    });
    
    form = dialog.find( "form" ).on( "submit", function( event ) {
      event.preventDefault();
      SaveTcDetails();
    });
});
</script>
</body>
</html>