<?php
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.db_connect.php');
error_reporting(E_ALL);

class StudentCcDetail
{
	// CLASS MEMBERS ARE DEFINED HERE	//
	private $LastErrorCode;
	private $DBObject; // VARIABLE TO HOLD THE DB CONNECTION //

	private $StudentCcdetailId;
	private $StudentID;



	private $Dateofadmission;
	private $Dateofleaving;
	private $CharacterBehaviour;
	private $MoralBehaviour;
	private $ExamnationSession;

	private $CreateUserID;
	private $Datetime;

	private $StudentIDList = array();

	// PUBLIC METHODS START HERE	//
	public function __construct($StudentCcdetailId = 0)
	{
		$this->DBObject = new DBConnect;
		$this->LastErrorCode = 0;

		if ($StudentCcdetailId != 0) {
			$this->StudentCcdetailId = $StudentCcdetailId;
			// SET THE VALUES FROM THE DATABASE.
			$this->GetStudentTcDetailByID();
		} else {
			//SET THE DEFAULT VALUES TO LOOK ATTRIBUTES
			$this->StudentCcdetailId = 0;
			$this->StudentID = 0;

			$this->Dateofadmission = '';
			$this->Dateofleaving = '';
			$this->CharacterBehaviour = '';

			$this->MoralBehaviour = '';
			$this->ExamnationSession = '';


			$this->CreateUserID = 0;
			$this->CreateDate = '0000-00-00 00:00:00';

			$this->StudentIDList = array();
		}
	}

	// GETTER AND SETTER FUNCTIONS START HERE	//
	public function GetStudentCcdetailId()
	{
		return $this->StudentCcdetailId;
	}

	public function GetStudentID()
	{
		return $this->StudentID;
	}
	public function SetStudentID($StudentID)
	{
		$this->StudentID = $StudentID;
	}

	public function GetDateofadmission()
	{
		return $this->Dateofadmission;
	}
	public function SetDateofadmission($Dateofadmission)
	{
		$this->Dateofadmission = $Dateofadmission;
	}

	public function GetDateofleaving()
	{
		return $this->Dateofleaving;
	}
	public function SetDateofleaving($Dateofleaving)
	{
		$this->Dateofleaving = $Dateofleaving;
	}

	public function GetCharacterBehaviour()
	{
		return $this->CharacterBehaviour;
	}
	public function SetCharacterBehaviour($CharacterBehaviour)
	{
		$this->CharacterBehaviour = $CharacterBehaviour;
	}

	public function GetMoralBehaviour()
	{
		return $this->MoralBehaviour;
	}
	public function SetMoralBehaviour($MoralBehaviour)
	{
		$this->MoralBehaviour = $MoralBehaviour;
	}

	public function GetExamnationSession()
	{
		return $this->ExamnationSession;
	}
	public function SetExamnationSession($ExamnationSession)
	{
		$this->ExamnationSession = $ExamnationSession;
	}
	public function GetCreateUserID()
	{
		return $this->CreateUserID;
	}
	public function SetCreateUserID($CreateUserID)
	{
		$this->CreateUserID = $CreateUserID;
	}

	public function GetCreateDate()
	{
		return $this->CreateDate;
	}

	public function GetStudentIDList()
	{
		return $this->StudentIDList;
	}
	public function SetStudentIDList($StudentIDList)
	{
		$this->StudentIDList = $StudentIDList;
	}

	public function GetLastErrorCode()
	{
		return $this->LastErrorCode;
	}

	//  END OF GETTER AND SETTER FUNCTIONS 	//

	public function Save()
	{
		try {
			return $this->SaveDetails();
		} catch (ApplicationDBException $e) {
			$this->LastErrorCode = $e->getCode();
			return false;
		} catch (ApplicationARException $e) {
			$this->LastErrorCode = $e->getCode();
			return false;
		} catch (Exception $e) {
			$this->LastErrorCode = APP_ERROR_UNDEFINED_ERROR;
			return false;
		}
	}

	public function Remove()
	{
		try {
			$this->RemoveStudentTcDetail();
			return true;
		} catch (ApplicationDBException $e) {
			$this->LastErrorCode = $e->getCode();
			return false;
		} catch (ApplicationARException $e) {
			$this->LastErrorCode = $e->getCode();
			return false;
		} catch (Exception $e) {
			$this->LastErrorCode = APP_ERROR_UNDEFINED_ERROR;
			return false;
		}
	}

	// END OF PUBLIC METHODS	//

	// START OF STATIC METHODS	//
	static function GetStudentCCDetails($StudentID)
	{
		$StudentTCDetails = array();

		try {
			$DBConnObject = new DBConnect();

			$RSSearch = $DBConnObject->Prepare('SELECT * FROM asa_student_cc_details WHERE studentID = :|1;');
			$RSSearch->Execute($StudentID);

			if ($RSSearch->Result->num_rows <= 0) {
				$StudentCCDetails = 0;
				return $StudentCCDetails;
			}

			while ($SearchRow = $RSSearch->FetchRow()) {


				$StudentCCDetails['Dateofadmission'] = $SearchRow->dateofadmission;
				$StudentCCDetails['Dateofleaving'] = $SearchRow->dateofleaving;
				$StudentCCDetails['CharacterBehaviour'] = $SearchRow->characterBehaviour;
				$StudentCCDetails['MoralBehaviour'] = $SearchRow->moralBehaviour;
				$StudentCCDetails['ExamnationSession'] = $SearchRow->examnationSession;

				$StudentCCDetails['Datetime'] = $SearchRow->datetime;
				$StudentCCDetails['CreateUserid'] = $SearchRow->createUserid;
			}

			return $StudentCCDetails;
		} catch (ApplicationDBException $e) {
			error_log('DEBUG: ApplicationDBException at StudentCcDetail::GetStudentCCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $StudentCCDetails;
		} catch (Exception $e) {
			error_log('DEBUG: Exception at StudentCcDetail::GetStudentCCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $StudentCCDetails;
		}
	}

	static function UpdateStudentTcDetails($TcDetailsToBeUpdate)
	{
		$UpdatedTcDetails = array();
		try {
			$DBConnObject = new DBConnect();

			if (count($TcDetailsToBeUpdate) > 0) {
				foreach ($TcDetailsToBeUpdate as $StudentID => $Details) {
					$RSUpdate = $DBConnObject->Prepare('UPDATE asa_student_tc_details
															SET	registrationNo = :|1,
																lastClassExamResult = :|2,
																promotedToHigherClass = :|3,
																isAnyconsession = :|4,
																numberOfPTM = :|5,
																paidAllDues = :|6,
																totalPresentDays = :|7,
																resultStatus = :|8,
																nccCadet = :|9,
																generalConduct = :|10,
																lastDateOfSession = :|11,
																tcIssueDate = :|12,
																schoolLeavingDate = :|13,
																reasonOfLeaving = :|14,
																subjectoffered = :|15,
																studentisfailed= :|16,
																otherRemark = :|17,
																createUserID = :|18,
																createDate = NOW()
															WHERE studentID = :|19 AND tcNumber = :|20 LIMIT 1;');
					$RSUpdate->Execute($Details['RegistrationNo'], $Details['LastClassExamResult'], $Details['PromotedToHigherClass'], $Details['AnyFeeConcession'], $Details['NoOfMeeting'], $Details['PaidAllDues'], $Details['TotalPresentDays'], $Details['ResultStatus'], $Details['NccCadet'], $Details['GeneralConduct'], $Details['LastDateOfSession'], $Details['TcIssueDate'], $Details['LeavingDate'], $Details['ReasonOfLeaving'], $Details['SubjectOffered'], $Details['Studentisfailed'], $Details['OtherRemark'], $Details['CreateUserID'], $StudentID, $Details['TCNumber']);
				}
			}

			return $UpdatedTcDetails = $TcDetailsToBeUpdate;
		} catch (ApplicationDBException $e) {
			error_log('DEBUG: ApplicationDBException at StudentTcDetail::UpdateStudentTcDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $UpdatedTcDetails;
		} catch (Exception $e) {
			error_log('DEBUG: Exception at StudentTcDetail::UpdateStudentTcDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $UpdatedTcDetails;
		}
	}

	static function SearchStudentCCDetails(&$TotalRecords = 0, $GetTotalsOnly = false, $Filters = array(), $Start = 0, $Limit = 100)
	{
		$CCStudentsList = array();

		try {
			$DBConnObject = new DBConnect();

			$Conditions = array();

			if (count($Filters) > 0) {
				if (!empty($Filters['ClassID'])) {
					$Conditions[] = 'ac.classID = ' . $DBConnObject->RealEscapeVariable($Filters['ClassID']);
				}

				if (!empty($Filters['ClassSectionID'])) {
					$Conditions[] = 'acs.classSectionID = ' . $DBConnObject->RealEscapeVariable($Filters['ClassSectionID']);
				}

				if (!empty($Filters['StudentID'])) {
					$Conditions[] = 'std.studentID = ' . $DBConnObject->RealEscapeVariable($Filters['StudentID']);
				}



				if (!empty($Filters['StudentName'])) {
					$Conditions[] = 'CONCAT(asd.firstName, " ", asd.lastName) LIKE ' . $DBConnObject->RealEscapeVariable('%' . $Filters['StudentName'] . '%');
				}
			}

			$QueryString = '';

			if (count($Conditions) > 0) {
				$QueryString = implode(') AND (', $Conditions);

				$QueryString = ' WHERE (' . $QueryString . ')';
			}

			if ($GetTotalsOnly) {


				$RSTotal = $DBConnObject->Prepare('SELECT COUNT(Distinct std.studentCcdetailId) AS totalRecords 
													FROM asa_student_cc_details std
													
                                                    INNER JOIN asa_student_details asd ON asd.studentID = std.studentId 
                                                    INNER JOIN asa_students ass ON ass.studentID = asd.studentID 
                                                    INNER JOIN asa_class_sections acs ON acs.classSectionID = ass.classSectionID 
                                                    INNER JOIN asa_classes ac ON ac.classID = acs.classID 
                                                    INNER JOIN asa_section_master asm ON asm.sectionMasterID = acs.sectionMasterID 
                                                    INNER JOIN users u ON std.createUserID = u.userID
													' . $QueryString . ';');
				$RSTotal->Execute();

				$TotalRecords = $RSTotal->FetchRow()->totalRecords;
				return;
			}


			$RSSearch = $DBConnObject->Prepare('SELECT std.*, ass.rollNumber, asd.firstName, asd.lastName, ac.className, asm.sectionName, u.userName AS createUserName
												FROM asa_student_cc_details std
												
                                                INNER JOIN asa_student_details asd ON asd.studentID = std.studentID 
                                                INNER JOIN asa_students ass ON ass.studentID = asd.studentID 
                                                INNER JOIN asa_class_sections acs ON acs.classSectionID = ass.classSectionID 
                                                INNER JOIN asa_classes ac ON ac.classID = acs.classID 
                                                INNER JOIN asa_section_master asm ON asm.sectionMasterID = acs.sectionMasterID 
                                                INNER JOIN users u ON std.createUserID = u.userID
												' . $QueryString . '
												ORDER BY asd.firstName, asd.lastName LIMIT ' . (int) $Start . ', ' . (int) $Limit . ';');
			$RSSearch->Execute();

			if ($RSSearch->Result->num_rows <= 0) {
				return $CCStudentsList;
			}

			while ($SearchRow = $RSSearch->FetchRow()) {
				$CCStudentsList[$SearchRow->studentCcdetailId]['StudentID'] = $SearchRow->studentId;
				$CCStudentsList[$SearchRow->studentCcdetailId]['StudentName'] = $SearchRow->firstName . ' ' . $SearchRow->lastName;
				$CCStudentsList[$SearchRow->studentCcdetailId]['RollNumber'] = $SearchRow->rollNumber;

				$CCStudentsList[$SearchRow->studentCcdetailId]['ClassName'] = $SearchRow->className;
				$CCStudentsList[$SearchRow->studentCcdetailId]['SectionName'] = $SearchRow->sectionName;

				$CCStudentsList[$SearchRow->studentCcdetailId]['dateofadmission'] = $SearchRow->dateofadmission;
				$CCStudentsList[$SearchRow->studentCcdetailId]['dateofleaving'] = $SearchRow->dateofleaving;
				$CCStudentsList[$SearchRow->studentCcdetailId]['characterBehaviour'] = $SearchRow->characterBehaviour;
				$CCStudentsList[$SearchRow->studentCcdetailId]['moralBehaviour'] = $SearchRow->moralBehaviour;
				$CCStudentsList[$SearchRow->studentCcdetailId]['examnationSession'] = $SearchRow->examnationSession;

				$CCStudentsList[$SearchRow->studentCcdetailId]['CreateUserName'] = $SearchRow->createUserid;
				$CCStudentsList[$SearchRow->studentCcdetailId]['CreateDate'] = $SearchRow->datetime;
			}

			return $CCStudentsList;
		} catch (ApplicationDBException $e) {
			error_log('DEBUG: ApplicationDBException at StudentCcDetail::SearchStudentCCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $CCStudentsList;
		} catch (Exception $e) {
			error_log('DEBUG: Exception at StudentCcDetail::SearchStudentCCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $CCStudentsList;
		}
	}

	static function AllStudentCCDetails($StudentID)
	{
		$AllStudentCCDetails = array();

		try {
			$DBConnObject = new DBConnect();

			$RSSearch = $DBConnObject->Prepare('SELECT * FROM cc_student_details WHERE studentID = :|1;');
			$RSSearch->Execute($StudentID);

			if ($RSSearch->Result->num_rows <= 0) {
				return $AllStudentCCDetails;
			}

			while ($SearchRow = $RSSearch->FetchRow()) {
				$AllStudentCCDetails[$SearchRow->studentID]['StudentID'] = $SearchRow->studentID;
				$AllStudentCCDetails[$SearchRow->studentID]['StudentName'] = $SearchRow->studentName;
				$AllStudentCCDetails[$SearchRow->studentID]['ParentsName'] = $SearchRow->parentsName;

				$AllStudentCCDetails[$SearchRow->studentID]['Address'] = $SearchRow->address;
				$AllStudentCCDetails[$SearchRow->studentID]['Class'] = $SearchRow->class;

				$AllStudentCCDetails[$SearchRow->studentID]['AdmissionDate'] = $SearchRow->admissionDate;
				$AllStudentCCDetails[$SearchRow->studentID]['AcademicYear'] = $SearchRow->academicYear;
			}
			return $AllStudentCCDetails;
		} catch (ApplicationDBException $e) {
			error_log('DEBUG: ApplicationDBException at StudentCcDetail::AllStudentCCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $AllStudentCCDetails;
		} catch (Exception $e) {
			error_log('DEBUG: Exception at StudentCcDetail::AllStudentCCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $AllStudentCCDetails;
		}
	}

	static function UpdateStudentCCDetails($StudentID, $StudentName,  $ParentsName,  $Class,  $Address,  $AdmissionDate, $AcademicYear)
	{

		$UpdatedCCDetails = array();

		try {
			$DBConnObject = new DBConnect();

			$RSSearch = $DBConnObject->Prepare('SELECT COUNT(*) AS totalRecords 
													 FROM cc_student_details WHERE studentID = :|1;');
			$RSSearch->Execute($StudentID);

			$TotalRecords = 0;

			$TotalRecords = $RSSearch->FetchRow()->totalRecords;

			if ($TotalRecords == 0) {
				$RSInsert = $DBConnObject->Prepare('INSERT INTO cc_student_details
															(studentID, studentName, parentsName, class, admissionDate, academicYear, address, createDate)
															VALUE(:|1, :|2, :|3, :|4, :|5, :|6, :|7, NOW());');
				$RSInsert->Execute($StudentID, $StudentName, $ParentsName, $Class, $AdmissionDate, $AcademicYear, $Address);
			} else {
				$RSUpdate = $DBConnObject->Prepare('UPDATE cc_student_details
																SET	studentName = :|1,
																	parentsName = :|2,
																	class = :|3,
																	admissionDate = :|4,
																	academicYear = :|5,
																	address = :|6,
																	createDate = NOW()
																WHERE studentID = :|7 LIMIT 1;');
				$RSUpdate->Execute($StudentName, $ParentsName, $Class, $AdmissionDate, $AcademicYear, $Address, $StudentID);
			}

			return true;
		} catch (ApplicationDBException $e) {
			error_log('DEBUG: ApplicationDBException at StudentCcDetail::UpdateStudentCCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $UpdatedCCDetails;
		} catch (Exception $e) {
			error_log('DEBUG: Exception at StudentCcDetail::UpdateStudentCCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $UpdatedCCDetails;
		}
	}

	static function DeleteStudentCC($StudentID)
	{
		try {
			$DBConnObject = new DBConnect();

			$RSDeleteTC = $DBConnObject->Prepare('DELETE FROM asa_student_cc_details WHERE studentID = :|1;');
			$RSDeleteTC->Execute($StudentID);



			return true;
		} catch (ApplicationDBException $e) {
			error_log('DEBUG: ApplicationDBException at StudentCcDetail::DeleteStudentCC(). Stack Trace: ' . $e->getTraceAsString());
			return false;
		} catch (Exception $e) {
			error_log('DEBUG: Exception at StudentCcDetail::DeleteStudentCC(). Stack Trace: ' . $e->getTraceAsString());
			return false;
		}
	}

	// END OF STATIC METHODS	//

	// START OF PRIVATE METHODS	//
	private function SaveDetails()
	{
		if (count($this->StudentIDList) > 0) {

			$RSSearchLastTcNumber = $this->DBObject->Prepare('SELECT MAX(studentId) AS studentId FROM asa_student_cc_details LIMIT 1;');
			$RSSearchLastTcNumber->Execute();



			foreach ($this->StudentIDList as $Key => $StudentID) {
				$RSSearch = $this->DBObject->Prepare('SELECT count(*) AS totalRecords FROM asa_student_cc_details WHERE studentID = :|1;');
				$RSSearch->Execute($this->StudentID);

				if ($RSSearch->FetchRow()->totalRecords > 0) {
					continue;
				}


				$RSSave = $this->DBObject->Prepare('INSERT INTO asa_student_cc_details (studentId, dateofadmission, dateofleaving, characterBehaviour, moralBehaviour, examnationSession, createUserid, datetime)
														VALUES (:|1, :|2, :|3, :|4, :|5, :|6, :|7, NOW());');

				//$RSSave->Execute($StudentID, ++$TcNumber, $this->RegistrationNo, $this->LastClassExamResult, $this->PromotedToHigherClass, $this->IsAnyconsession, $this->NumberOfPTM, $this->PaidAllDues, $this->TotalPresentDays, 'Yes', '', 'Satisfactory', $this->LastDateOfSession, $this->TcIssueDate, $this->SchoolLeavingDate, $this->ReasonOfLeaving, '', $this->CreateUserID);
				$RSSave->Execute($StudentID,  $this->Dateofadmission, $this->Dateofleaving, $this->CharacterBehaviour, $this->MoralBehaviour, $this->ExamnationSession, $this->CreateUserID);

				/* $RSUpdateStudent = $this->DBObject->Prepare('UPDATE asa_students
    															SET	status = :|1
    															WHERE studentID = :|2 LIMIT 1;');
    													
    				$RSUpdateStudent->Execute('CC', $StudentID); */
			}
		}

		return true;
	}

	private function RemoveStudentTcDetail()
	{
		if (!isset($this->StudentTcDetailID)) {
			throw new ApplicationARException('', APP_AR_ERROR_DELETE_WITHOUT_ID);
		}

		$RSDeleteStudentTcDetail = $this->DBObject->Prepare('DELETE FROM asa_student_cc_details WHERE studentTcDetailID = :|1 LIMIT 1;');
		$RSDeleteStudentTcDetail->Execute($this->StudentTcDetailID);

		return true;
	}

	private function GetStudentCcDetailByID()
	{
		$RSStudentTcDetail = $this->DBObject->Prepare('SELECT studentCcdetailId, studentId, dateofadmission, dateofleaving, characterBehaviour, moralBehaviour, examnationSession, createUserid, datetime FROM asa_student_cc_details WHERE studentId = :|1;');
		$RSStudentTcDetail->Execute($this->StudentID);

		$StudentTcDetailRow = $RSStudentTcDetail->FetchRow();

		$this->SetAttributesFromDB($StudentTcDetailRow);
	}

	private function SetAttributesFromDB($StudentTcDetailRow)
	{
		$this->StudentTcDetailID = $StudentTcDetailRow->studentTcDetailID;
		$this->StudentID = $StudentTcDetailRow->studentID;

		$this->TcNumber = $StudentTcDetailRow->tcNumber;
		$this->RegistrationNo = $StudentTcDetailRow->registrationNo;

		$this->LastClassExamResult = $StudentTcDetailRow->lastClassExamResult;
		$this->PromotedToHigherClass = $StudentTcDetailRow->promotedToHigherClass;
		$this->IsAnyconsession = $StudentTcDetailRow->isAnyconsession;
		$this->NumberOfPTM = $StudentTcDetailRow->numberOfPTM;

		$this->PaidAllDues = $StudentTcDetailRow->paidAllDues;
		$this->TotalPresentDays = $StudentTcDetailRow->totalPresentDays;

		$this->ResultStatus = $StudentTcDetailRow->resultStatus;
		$this->NccCadet = $StudentTcDetailRow->nccCadet;
		$this->GeneralConduct = $StudentTcDetailRow->generalConduct;

		$this->LastDateOfSession = $StudentTcDetailRow->lastDateOfSession;
		$this->TcIssueDate = $StudentTcDetailRow->tcIssueDate;
		$this->SchoolLeavingDate = $StudentTcDetailRow->schoolLeavingDate;

		$this->ReasonOfLeaving = $StudentTcDetailRow->studentisfailed;
		$this->Studentisfailed = $StudentTcDetailRow->Studentisfailed;
		$this->SubjectOffered = $StudentTcDetailRow->subjectoffered;

		$this->OtherRemark = $StudentTcDetailRow->otherRemark;

		$this->CreateUserID = $StudentTcDetailRow->createUserID;
		$this->CreateDate = $StudentTcDetailRow->createDate;
	}
}
