<?php
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.db_connect.php');
error_reporting(E_ALL);

class StudentTcDetail
{
	// CLASS MEMBERS ARE DEFINED HERE	//
	private $LastErrorCode;
	private $DBObject; // VARIABLE TO HOLD THE DB CONNECTION //
	
	private $StudentTcDetailID;
	private $StudentID;

	private $TcNumber;
	private $RegistrationNo;

	private $LastClassExamResult;
	private $PromotedToHigherClass;
	private $IsAnyconsession;
	private $NumberOfPTM;

	private $PaidAllDues;
	private $TotalPresentDays;

	private $ResultStatus;
	private $NccCadet;
	private $GeneralConduct;

	private $LastDateOfSession;
	private $TcIssueDate;
	private $SchoolLeavingDate;

	private $StuckOffClass;
	private $ReasonOfLeaving;
	private $NoOfWorkingDays;
	private $OtherRemark;

	private $CreateUserID;
	private $CreateDate;

	private $StudentIDList = array();

	// PUBLIC METHODS START HERE	//
	public function __construct($StudentTcDetailID = 0)
	{
		$this->DBObject = new DBConnect;
		$this->LastErrorCode = 0;
		
		if($StudentTcDetailID != 0)
		{
			$this->StudentTcDetailID = $StudentTcDetailID;
			// SET THE VALUES FROM THE DATABASE.
			$this->GetStudentTcDetailByID();
		}
		else
		{
			//SET THE DEFAULT VALUES TO LOOK ATTRIBUTES
			$this->StudentTcDetailID = 0;
			$this->StudentID = 0;

			$this->TcNumber = '';
			$this->RegistrationNo = '';

			$this->LastClassExamResult = '';
			$this->PromotedToHigherClass = '';
			$this->IsAnyconsession = '';
			$this->NumberOfPTM = '';

			$this->PaidAllDues = '';
			$this->TotalPresentDays = '';

			$this->ResultStatus = '';
			$this->NccCadet = '';
			$this->GeneralConduct = '';

			$this->LastDateOfSession = '';
			$this->TcIssueDate = '';
			$this->SchoolLeavingDate = '';

			$this->StuckOffClass = '';
			$this->ReasonOfLeaving = '';
			$this->NoOfWorkingDays = '';
			$this->OtherRemark = '';

			$this->CreateUserID = 0;
			$this->CreateDate = '0000-00-00 00:00:00';

			$this->StudentIDList = array();
		}
	}
	
	// GETTER AND SETTER FUNCTIONS START HERE	//
	public function GetStudentTcDetailID()
	{
		return $this->StudentTcDetailID;
	}
	
	public function GetStudentID()
	{
		return $this->StudentID;
	}
	public function SetStudentID($StudentID)
	{
		$this->StudentID = $StudentID;
	}

	public function GetTcNumber()
	{
		return $this->TcNumber;
	}
	public function SetTcNumber($TcNumber)
	{
		$this->TcNumber = $TcNumber;
	}

	public function GetRegistrationNo()
	{
		return $this->RegistrationNo;
	}
	public function SetRegistrationNo($RegistrationNo)
	{
		$this->RegistrationNo = $RegistrationNo;
	}

	public function GetLastClassExamResult()
	{
		return $this->LastClassExamResult;
	}
	public function SetLastClassExamResult($LastClassExamResult)
	{
		$this->LastClassExamResult = $LastClassExamResult;
	}

	public function GetPromotedToHigherClass()
	{
		return $this->PromotedToHigherClass;
	}
	public function SetPromotedToHigherClass($PromotedToHigherClass)
	{
		$this->PromotedToHigherClass = $PromotedToHigherClass;
	}

	public function GetIsAnyconsession()
	{
		return $this->IsAnyconsession;
	}
	public function SetIsAnyconsession($IsAnyconsession)
	{
		$this->IsAnyconsession = $IsAnyconsession;
	}

	public function GetNumberOfPTM()
	{
		return $this->NumberOfPTM;
	}
	public function SetNumberOfPTM($NumberOfPTM)
	{
		$this->NumberOfPTM = $NumberOfPTM;
	}

	public function GetPaidAllDues()
	{
		return $this->PaidAllDues;
	}
	public function SetPaidAllDues($PaidAllDues)
	{
		$this->NumberOfPTM = $NumberOfPTM;
	}

	public function GetTotalPresentDays()
	{
		return $this->TotalPresentDays;
	}
	public function SetTotalPresentDays($TotalPresentDays)
	{
		$this->TotalPresentDays = $TotalPresentDays;
	}

	public function GetResultStatus()
	{
		return $this->ResultStatus;
	}
	public function SetResultStatus($ResultStatus)
	{
		$this->ResultStatus = $ResultStatus;
	}

	public function GetNccCadet()
	{
		return $this->NccCadet;
	}
	public function SetNccCadet($NccCadet)
	{
		$this->NccCadet = $NccCadet;
	}

	public function GetGeneralConduct()
	{
		return $this->GeneralConduct;
	}
	public function SetGeneralConduct($GeneralConduct)
	{
		$this->GeneralConduct = $GeneralConduct;
	}

	public function GetLastDateOfSession()
	{
		return $this->LastDateOfSession;
	}
	public function SetLastDateOfSession($LastDateOfSession)
	{
		$this->LastDateOfSession = $LastDateOfSession;
	}

	public function GetTcIssueDate()
	{
		return $this->TcIssueDate;
	}
	public function SetTcIssueDate($TcIssueDate)
	{
		$this->TcIssueDate = $TcIssueDate;
	}

	public function GetSchoolLeavingDate()
	{
		return $this->SchoolLeavingDate;
	}
	public function SetSchoolLeavingDate($SchoolLeavingDate)
	{
		$this->SchoolLeavingDate = $SchoolLeavingDate;
	}

	public function GetStuckOffClass()
	{
		return $this->StuckOffClass;
	}
	public function SetStuckOffClass($StuckOffClass)
	{
		$this->StuckOffClass = $StuckOffClass;
	}
	
	public function GetReasonOfLeaving()
	{
		return $this->ReasonOfLeaving;
	}
	public function SetReasonOfLeaving($ReasonOfLeaving)
	{
		$this->ReasonOfLeaving = $ReasonOfLeaving;
	}
	
	public function GetNoOfWorkingDays()
	{
		return $this->NoOfWorkingDays;
	}
	public function SetNoOfWorkingDays($NoOfWorkingDays)
	{
		$this->NoOfWorkingDays = $NoOfWorkingDays;
	}

	public function GetOtherRemark()
	{
		return $this->OtherRemark;
	}
	public function SetOtherRemark($OtherRemark)
	{
		$this->OtherRemark = $OtherRemark;
	}

	public function GetCreateUserID()
	{
		return $this->CreateUserID;
	}
	public function SetCreateUserID($CreateUserID)
	{
		$this->CreateUserID = $CreateUserID;
	}

	public function GetCreateDate()
	{
		return $this->CreateDate;
	}

	public function GetStudentIDList()
	{
		return $this->StudentIDList;
	}
	public function SetStudentIDList($StudentIDList)
	{
		$this->StudentIDList = $StudentIDList;
	}

	public function GetLastErrorCode()
	{
		return $this->LastErrorCode;
	}
	
	//  END OF GETTER AND SETTER FUNCTIONS 	//
	
	public function Save()
	{
		try
		{
			return $this->SaveDetails();
		}
		catch (ApplicationDBException $e)
		{
			$this->LastErrorCode = $e->getCode();
			return false;
		}
		catch (ApplicationARException $e)
		{
			$this->LastErrorCode = $e->getCode();
			return false;
		}
		catch (Exception $e)
		{
			$this->LastErrorCode = APP_ERROR_UNDEFINED_ERROR;
			return false;
		}
	}

	public function Remove()
    {
        try
        {
            $this->RemoveStudentTcDetail();
            return true;
        }
        catch (ApplicationDBException $e)
        {
            $this->LastErrorCode = $e->getCode();
            return false;
        }
        catch (ApplicationARException $e)
        {
            $this->LastErrorCode = $e->getCode();
            return false;
        }
        catch (Exception $e)
        {
            $this->LastErrorCode = APP_ERROR_UNDEFINED_ERROR;
            return false;
        }
    }
	
	// END OF PUBLIC METHODS	//
	
	// START OF STATIC METHODS	//
	static function GetStudentTCDetails($StudentID)
	{		
	    $StudentTCDetails = array();
	    
		try
		{
			$DBConnObject = new DBConnect();
			
			//$RSSearch = $DBConnObject->Prepare('SELECT * FROM asa_student_tc_details WHERE studentID = :|1 LIMIT 1;');
			$RSSearch = $DBConnObject->Prepare('SELECT * FROM asa_student_tc_details_new WHERE studentID = :|1 LIMIT 1;');
	        $RSSearch->Execute($StudentID);
	        
	        if ($RSSearch->Result->num_rows <= 0)
	        {
	            return $StudentTCDetails;
	        }
			
			while($SearchRow = $RSSearch->FetchRow())
			{
				$StudentTCDetails['StudentID'] = $SearchRow->studentID;
				$StudentTCDetails['TcNumber'] = $SearchRow->tcNumber;
				$StudentTCDetails['Details'] = $SearchRow->details;
				$StudentTCDetails['CreateUserID'] = $SearchRow->createUserID;
				$StudentTCDetails['CreateDate'] = $SearchRow->createDate;
			}
			
			return $StudentTCDetails;
		}
		catch (ApplicationDBException $e)
		{
			error_log('DEBUG: ApplicationDBException at StudentTcDetail::GetStudentTCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $StudentTCDetails;
		}
		catch (Exception $e)
		{
			error_log('DEBUG: Exception at StudentTcDetail::GetStudentTCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $StudentTCDetails;
		}		
	}
	
	static function InsertStudentTCDetails($StudentID, $TCNumber, $Details, $CreateUserID)
	{
	    try
		{
			$DBConnObject = new DBConnect();
			
			$RSDELETE = $DBConnObject->Prepare('DELETE FROM asa_student_tc_details_new WHERE studentID = :|1;');
			$RSDELETE->Execute($StudentID);
			
			$RSInsert = $DBConnObject->Prepare('INSERT INTO asa_student_tc_details_new 
			                                    (studentID, tcNumber, details, createUserID, createDate)
			                                    VALUE (:|1, :|2, :|3, :|4, NOW());');

			$RSInsert->Execute($StudentID, $TCNumber, $Details, $CreateUserID);
			
			return true;	
		}
		catch (ApplicationDBException $e)
		{
			error_log('DEBUG: ApplicationDBException at StudentTcDetail::InsertStudentTCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return false;
		}
		catch (Exception $e)
		{
			error_log('DEBUG: Exception at StudentTcDetail::InsertStudentTCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return false;
		}
	}
	
	static function UpdateStudentTcDetails($TcDetailsToBeUpdate)
	{		
		$UpdatedTcDetails = array();
		try
		{
			$DBConnObject = new DBConnect();
			
			if (count($TcDetailsToBeUpdate) > 0) 
			{
				foreach ($TcDetailsToBeUpdate as $StudentID => $Details) 
				{
					$RSUpdate = $DBConnObject->Prepare('UPDATE asa_student_tc_details
															SET	registrationNo = :|1,
																lastClassExamResult = :|2,
																promotedToHigherClass = :|3,
																isAnyconsession = :|4,
																numberOfPTM = :|5,
																paidAllDues = :|6,
																totalPresentDays = :|7,
																resultStatus = :|8,
																nccCadet = :|9,
																generalConduct = :|10,
																lastDateOfSession = :|11,
																tcIssueDate = :|12,
																schoolLeavingDate = :|13,
																stuckOffClass = :|14,
																reasonOfLeaving = :|15,
																noOfWorkingDays = :|16,
																otherRemark = :|17,
																createUserID = :|18,
																createDate = NOW()
															WHERE studentID = :|19 AND tcNumber = :|20 LIMIT 1;');
					$RSUpdate->Execute($Details['RegistrationNo'], $Details['LastClassExamResult'], $Details['PromotedToHigherClass'], $Details['AnyFeeConcession'], $Details['NoOfMeeting'], $Details['PaidAllDues'], $Details['TotalPresentDays'], $Details['ResultStatus'], $Details['NccCadet'], $Details['GeneralConduct'], $Details['LastDateOfSession'], $Details['TcIssueDate'], $Details['LeavingDate'], $Details['StuckOffClass'], $Details['ReasonOfLeaving'], $Details['NoOfWorkingDays'], $Details['OtherRemark'], $Details['CreateUserID'], $StudentID, $Details['TCNumber']);
				}
			}
			
			return $UpdatedTcDetails = $TcDetailsToBeUpdate;	
		}
		catch (ApplicationDBException $e)
		{
			error_log('DEBUG: ApplicationDBException at StudentTcDetail::UpdateStudentTcDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $UpdatedTcDetails;
		}
		catch (Exception $e)
		{
			error_log('DEBUG: Exception at StudentTcDetail::UpdateStudentTcDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $UpdatedTcDetails;
		}		
	}
	
	static function SearchStudentTCDetails(&$TotalRecords = 0, $GetTotalsOnly = false, $Filters = array(), $Start = 0, $Limit = 100)
	{
		$TCStudentsList = array();
		
		try
		{
			$DBConnObject = new DBConnect();

			$Conditions = array();
			
			if (count($Filters) > 0)
			{
			    if (!empty($Filters['ClassID']))
				{
					$Conditions[] = 'ac.classID = '. $DBConnObject->RealEscapeVariable($Filters['ClassID']);
				}

				if (!empty($Filters['ClassSectionID']))
				{
					$Conditions[] = 'acs.classSectionID = '. $DBConnObject->RealEscapeVariable($Filters['ClassSectionID']);
				}
				
				if (!empty($Filters['StudentID']))
				{
					$Conditions[] = 'std.studentID = '. $DBConnObject->RealEscapeVariable($Filters['StudentID']);
				}
				
				if (!empty($Filters['SessionLastDate']))
				{
					$Conditions[] = 'std.lastDateOfSession = '. $DBConnObject->RealEscapeVariable($Filters['SessionLastDate']);
				}
				
				if (!empty($Filters['TCIssueDate']))
				{
					$Conditions[] = 'std.tcIssueDate = '. $DBConnObject->RealEscapeVariable($Filters['TCIssueDate']);
				}
				
				if (!empty($Filters['SchoolLeavingDate']))
				{
					$Conditions[] = 'std.schoolLeavingDate = '. $DBConnObject->RealEscapeVariable($Filters['SchoolLeavingDate']);
				}
				
				if (!empty($Filters['ReasonForLeaving']))
				{
					$Conditions[] = 'std.reasonOfLeaving = '. $DBConnObject->RealEscapeVariable($Filters['ReasonForLeaving']);
				}
				
				if (!empty($Filters['StudentName']))
				{
					$Conditions[] = 'CONCAT(asd.firstName, " ", asd.lastName) LIKE ' . $DBConnObject->RealEscapeVariable('%' . $Filters['StudentName'] . '%');
				}
			}
			
			$QueryString = '';

			if (count($Conditions) > 0)
			{
				$QueryString = implode(') AND (', $Conditions);
				
				$QueryString = ' WHERE (' . $QueryString . ')';
			}

			if ($GetTotalsOnly)
			{
				$RSTotal = $DBConnObject->Prepare('SELECT COUNT(Distinct std.studentTcDetailID) AS totalRecords 
													FROM asa_student_tc_details std
													
                                                    INNER JOIN asa_student_details asd ON asd.studentID = std.studentID 
                                                    INNER JOIN asa_students ass ON ass.studentID = asd.studentID 
                                                    INNER JOIN asa_class_sections acs ON acs.classSectionID = ass.classSectionID 
                                                    INNER JOIN asa_classes ac ON ac.classID = acs.classID 
                                                    INNER JOIN asa_section_master asm ON asm.sectionMasterID = acs.sectionMasterID 
                                                    INNER JOIN users u ON std.createUserID = u.userID
													'. $QueryString .';');
				$RSTotal->Execute();
				
				$TotalRecords = $RSTotal->FetchRow()->totalRecords;
				return;
			}
			
			$RSSearch = $DBConnObject->Prepare('SELECT std.*, ass.rollNumber, asd.firstName, asd.lastName, ac.className, asm.sectionName, u.userName AS createUserName
												FROM asa_student_tc_details std
												
                                                INNER JOIN asa_student_details asd ON asd.studentID = std.studentID 
                                                INNER JOIN asa_students ass ON ass.studentID = asd.studentID 
                                                INNER JOIN asa_class_sections acs ON acs.classSectionID = ass.classSectionID 
                                                INNER JOIN asa_classes ac ON ac.classID = acs.classID 
                                                INNER JOIN asa_section_master asm ON asm.sectionMasterID = acs.sectionMasterID 
                                                INNER JOIN users u ON std.createUserID = u.userID
												'. $QueryString .'
												ORDER BY asd.firstName, asd.lastName LIMIT ' . (int) $Start . ', ' . (int) $Limit . ';');
			$RSSearch->Execute();
			
			if ($RSSearch->Result->num_rows <= 0)
			{
				return $TCStudentsList; 
			}
			
			while($SearchRow = $RSSearch->FetchRow())
			{
			    $TCStudentsList[$SearchRow->studentTcDetailID]['StudentID'] = $SearchRow->studentID;
				$TCStudentsList[$SearchRow->studentTcDetailID]['StudentName'] = $SearchRow->firstName .' '. $SearchRow->lastName;
				$TCStudentsList[$SearchRow->studentTcDetailID]['RollNumber'] = $SearchRow->rollNumber;

				$TCStudentsList[$SearchRow->studentTcDetailID]['ClassName'] = $SearchRow->className;
				$TCStudentsList[$SearchRow->studentTcDetailID]['SectionName'] = $SearchRow->sectionName;
				
				$TCStudentsList[$SearchRow->studentTcDetailID]['TcNumber'] = $SearchRow->tcNumber;
				$TCStudentsList[$SearchRow->studentTcDetailID]['ResultStatus'] = $SearchRow->resultStatus;
				$TCStudentsList[$SearchRow->studentTcDetailID]['NccCadet'] = $SearchRow->nccCadet;
				$TCStudentsList[$SearchRow->studentTcDetailID]['GeneralConduct'] = $SearchRow->generalConduct;
				$TCStudentsList[$SearchRow->studentTcDetailID]['LastDateOfSession'] = $SearchRow->lastDateOfSession;
				$TCStudentsList[$SearchRow->studentTcDetailID]['TcIssueDate'] = $SearchRow->tcIssueDate;
				$TCStudentsList[$SearchRow->studentTcDetailID]['SchoolLeavingDate'] = $SearchRow->schoolLeavingDate;
				$TCStudentsList[$SearchRow->studentTcDetailID]['StuckOffClass'] = $SearchRow->stuckOffClass;
				$TCStudentsList[$SearchRow->studentTcDetailID]['ReasonOfLeaving'] = $SearchRow->reasonOfLeaving;
				$TCStudentsList[$SearchRow->studentTcDetailID]['NoOfWorkingDays'] = $SearchRow->noOfWorkingDays;
				$TCStudentsList[$SearchRow->studentTcDetailID]['OtherRemark'] = $SearchRow->otherRemark;
				 			
				$TCStudentsList[$SearchRow->studentTcDetailID]['CreateUserName'] = $SearchRow->createUserName;
				$TCStudentsList[$SearchRow->studentTcDetailID]['CreateDate'] = $SearchRow->createDate;
			}
			
			return $TCStudentsList;	
		}
		catch (ApplicationDBException $e)
		{
			error_log('DEBUG: ApplicationDBException at StudentTcDetail::SearchStudentTCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $TCStudentsList;
		}
		catch (Exception $e)
		{
			error_log('DEBUG: Exception at StudentTcDetail::SearchStudentTCDetails(). Stack Trace: ' . $e->getTraceAsString());
			return $TCStudentsList;
		}
	}
	
	static function DeleteStudentTC($StudentID)
	{		
		try
		{
			$DBConnObject = new DBConnect();
			
		    $RSDeleteTC = $DBConnObject->Prepare('DELETE FROM asa_student_tc_details WHERE studentID = :|1;');
	        $RSDeleteTC->Execute($StudentID);
	        
	        $RSUpdateStudent = $DBConnObject->Prepare('UPDATE asa_students
														SET	status = :|1
														WHERE studentID = :|2 LIMIT 1;');
												
			$RSUpdateStudent->Execute('Active', $StudentID);
			
			return true;
		}
		catch (ApplicationDBException $e)
		{
			error_log('DEBUG: ApplicationDBException at StudentTcDetail::DeleteStudentTC(). Stack Trace: ' . $e->getTraceAsString());
			return false;
		}
		catch (Exception $e)
		{
			error_log('DEBUG: Exception at StudentTcDetail::DeleteStudentTC(). Stack Trace: ' . $e->getTraceAsString());
			return false;
		}		
	}
	
	// END OF STATIC METHODS	//
	
	// START OF PRIVATE METHODS	//
	private function SaveDetails()
	{
		if (count($this->StudentIDList) > 0) 
		{	
				$TcNumber = 0;

				$RSSearchLastTcNumber = $this->DBObject->Prepare('SELECT MAX(tcNumber) AS tcNumber FROM asa_student_tc_details LIMIT 1;');
		        $RSSearchLastTcNumber->Execute();
		        
		        if ($RSSearchLastTcNumber->Result->num_rows > 0)
		        {
		            $TcNumber = $RSSearchLastTcNumber->FetchRow()->tcNumber;
		        }

		        foreach ($this->StudentIDList as $Key => $StudentID) 
				{
				    $RSSearch = $this->DBObject->Prepare('SELECT count(*) AS totalRecords FROM asa_student_tc_details WHERE studentID = :|1;');
    		        $RSSearch->Execute($StudentID);
    		        
    		        if ($RSSearch->FetchRow()->totalRecords > 0)
    		        {
    		            continue;
    		        }

					$RSSave = $this->DBObject->Prepare('INSERT INTO asa_student_tc_details (studentID, tcNumber, registrationNo, lastClassExamResult, promotedToHigherClass, isAnyconsession, numberOfPTM, paidAllDues, totalPresentDays, resultStatus, nccCadet, generalConduct, lastDateOfSession, tcIssueDate, schoolLeavingDate, stuckOffClass, reasonOfLeaving, noOfWorkingDays, otherRemark, createUserID, createDate)
														VALUES (:|1, :|2, :|3, :|4, :|5, :|6, :|7, :|8, :|9, :|10, :|11, :|12, :|13, :|14, :|15, :|16, :|17, :|18, :|19, :|20, NOW());');

					$RSSave->Execute($StudentID, ++$TcNumber, $this->RegistrationNo, $this->LastClassExamResult, $this->PromotedToHigherClass, $this->IsAnyconsession, $this->NumberOfPTM, $this->PaidAllDues, $this->TotalPresentDays, 'Yes', '', 'Satisfactory', $this->LastDateOfSession, $this->TcIssueDate, $this->SchoolLeavingDate, $this->StuckOffClass, $this->ReasonOfLeaving, $this->NoOfWorkingDays, '', $this->CreateUserID);

					$RSUpdateStudent = $this->DBObject->Prepare('UPDATE asa_students
    															SET	status = :|1
    															WHERE studentID = :|2 LIMIT 1;');
    													
    				$RSUpdateStudent->Execute('TC', $StudentID);
				}
		}
		
		return true;
	}

	private function RemoveStudentTcDetail()
    {
        if(!isset($this->StudentTcDetailID)) 
        {
            throw new ApplicationARException('', APP_AR_ERROR_DELETE_WITHOUT_ID);
        }
        
        $RSDeleteStudentTcDetail = $this->DBObject->Prepare('DELETE FROM asa_student_tc_details WHERE studentTcDetailID = :|1 LIMIT 1;');
        $RSDeleteStudentTcDetail->Execute($this->StudentTcDetailID); 

        return true;               
    }

	private function GetStudentTcDetailByID()
	{
		$RSStudentTcDetail = $this->DBObject->Prepare('SELECT * FROM asa_student_tc_details WHERE studentTcDetailID = :|1;');
		$RSStudentTcDetail->Execute($this->StudentTcDetailID);
		
		$StudentTcDetailRow = $RSStudentTcDetail->FetchRow();
		
		$this->SetAttributesFromDB($StudentTcDetailRow);				
	}

	private function SetAttributesFromDB($StudentTcDetailRow)
	{
		$this->StudentTcDetailID = $StudentTcDetailRow->studentTcDetailID;
		$this->StudentID = $StudentTcDetailRow->studentID;

		$this->TcNumber = $StudentTcDetailRow->tcNumber;
		$this->RegistrationNo = $StudentTcDetailRow->registrationNo;

		$this->LastClassExamResult = $StudentTcDetailRow->lastClassExamResult;
		$this->PromotedToHigherClass = $StudentTcDetailRow->promotedToHigherClass;
		$this->IsAnyconsession = $StudentTcDetailRow->isAnyconsession;
		$this->NumberOfPTM = $StudentTcDetailRow->numberOfPTM;

		$this->PaidAllDues = $StudentTcDetailRow->paidAllDues;
		$this->TotalPresentDays = $StudentTcDetailRow->totalPresentDays;

		$this->ResultStatus = $StudentTcDetailRow->resultStatus;
		$this->NccCadet = $StudentTcDetailRow->nccCadet;
		$this->GeneralConduct = $StudentTcDetailRow->generalConduct;

		$this->LastDateOfSession = $StudentTcDetailRow->lastDateOfSession;
		$this->TcIssueDate = $StudentTcDetailRow->tcIssueDate;
		$this->SchoolLeavingDate = $StudentTcDetailRow->schoolLeavingDate;

		$this->StuckOffClass = $StudentTcDetailRow->stuckOffClass;
		$this->ReasonOfLeaving = $StudentTcDetailRow->reasonOfLeaving;
		$this->NoOfWorkingDays = $StudentTcDetailRow->noOfWorkingDays;
		$this->OtherRemark = $StudentTcDetailRow->otherRemark;

		$this->CreateUserID = $StudentTcDetailRow->createUserID;
		$this->CreateDate = $StudentTcDetailRow->createDate;

	}	
}
?>