<?php
header("Content-Type:application/json");

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.users.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.validation.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.authentication.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/class.date_processing.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/includes/global_defaults.inc.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.json_response.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/global_defaults.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/includes/process_errors.php');

//	Other Required Classess
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/school_administration/class.classes.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/school_administration/class.class_sections.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/school_administration/class.students.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/school_administration/class.student_details.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/academic_supervision/class.remarks.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/school_administration/class.branch_staff.php');
require_once($_SERVER['DOCUMENT_ROOT'] . '/mobile_app_services/classes/class.app.branch_staff.php');

require_once($_SERVER['DOCUMENT_ROOT'] . '/classes/academic_supervision/class.student_assignment.php');

$Response = new JSONResponse();

$Clean = array();
$Filters = array();

$Clean['UniqueToken'] = md5(uniqid(rand(), true));

//	Other Variables
$Clean['ClassID'] = 0;
$Clean['ClassSectionID'] = 0;
$Clean['AssignmentID'] = 0;

$Clean['ClassSubjectID'] = 0;
$Clean['IssueDate'] = '';

if (isset($_REQUEST['Token']))
{
	$Clean['UniqueToken'] = strip_tags(trim((string) $_REQUEST['Token']));
}

if (isset($_REQUEST['ClassID']))
{
	$Clean['ClassID'] = (int) $_REQUEST['ClassID'];
}

if (isset($_REQUEST['ClassSectionID']))
{
	$Clean['ClassSectionID'] = (int) $_REQUEST['ClassSectionID'];
}

if (isset($_REQUEST['AssignmentID']))
{
	$Clean['AssignmentID'] = (int) $_REQUEST['AssignmentID'];
}

if (isset($_REQUEST['ClassSubjectID']))
{
	$Clean['ClassSubjectID'] = (int) $_REQUEST['ClassSubjectID'];
}

if (isset($_REQUEST['IssueDate']))
{
	$Clean['IssueDate'] = strip_tags(trim($_REQUEST['IssueDate']));
}

try
{
	$LoggedInBranchStaff = new AppBranchStaff($Clean['UniqueToken']);

	/*if ($Clean['ClassSectionID'] <= 0 || $Clean['AssignmentID'] <= 0)
	{
		$Response->SetError(1);
		$Response->SetErrorCode(UNKNOWN_ERROR);
		$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

		echo json_encode($Response->GetResponseAsArray());
		exit;
	}*/

    //set record filters
    
    if ($Clean['ClassID'])
    {
        $Filters['ClassID'] = $Clean['ClassID'];
    }
    if ($Clean['ClassSectionID'])
    {
        $Filters['ClassSectionID'] = $Clean['ClassSectionID'];
    }
    if ($Clean['AssignmentID'])
    {
        $Filters['AssignmentID'] = $Clean['AssignmentID'];
    }
    if ($Clean['ClassSubjectID'])
    {
        $Filters['ClassSubjectID'] = $Clean['ClassSubjectID'];
    }
    if ($Clean['IssueDate'])
    {
        $Filters['IssueDate'] = $Clean['IssueDate'];
    }

    // paging and sorting variables start here  //
	$TotalPages = 0;

	$Start = 0;
	//$Limit = GLOBAL_SITE_PAGGING;
	$Limit = 2000;

	$StudentAssignmentAnswerList = array();
	// end of paging variables//
    //get records count
    
    StudentAssignment::SearchAssignmentAnswerList($TotalRecords, true, $Filters);

    if ($TotalRecords > 0)
    {
        $StudentAssignmentAnswerList = StudentAssignment::SearchAssignmentAnswerList($TotalRecords, false, $Filters, $Start, $TotalRecords);
    }
    
    $Response->PushData('student_assignment_answer_list', $StudentAssignmentAnswerList);
}
catch (ApplicationDBException $e)
{
    $Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));

	echo json_encode($Response->GetResponseAsArray());
	exit;
}
catch (Exception $e)
{
	$Response->SetError(1);
	$Response->SetErrorCode(UNKNOWN_ERROR);
	$Response->SetMessage(ProcessAppErrors(UNKNOWN_ERROR));
	
	echo json_encode($Response->GetResponseAsArray());
	exit;
}

echo json_encode($Response->GetResponseAsArray());
exit;
?>